
<!DOCTYPE html>
<?php
    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    $email = $_SESSION['email'];
     
    $controlador = new ControladorUsuario();
    if(!$controlador->setUser($email)) {
        header("Location: login.php");
    }
    $imageurl = $controlador->getImage(); 
    $index =0;
    
    if(isset($_GET['index'])) {
        $index = $_GET['index'];
    } else {
        $_GET['index']=0;
    }

    include './controladores/Turma.php';
    $isAluno = $controlador->ehAluno();
    if($isAluno) {
        include './controladores/Aluno.php';
        $controlador = $controlador->getAluno();
        $turma = $controlador->getTurma();
        if($turma===null) {
             header("Location: class.php");           
        }
    } else {
         include './controladores/Professor.php';       
         $controlador = $controlador->getProfessor();
         $index = 0;
         if(isset($_GET['index'])) {
             $index = (int)$_GET['index'];
         }
         
         $turma = $controlador->getTurmaByIndex($index);
         if(!$turma) {
             echo 'Turma não encontrada';
             return;
         }
         
    }
    $details = $turma->getDescricaoTurma();
    $title = $details['disciplina_nome'].' ('.$details['curso_sigla'].') - '.$turma->getAno();   
    $alunos = $turma->getAlunos();  
    
    if($imageurl!=null && $imageurl!=='') {
        $imageurl = $imageurl.'?='.rand();
    } else {
        $imageurl = 'images/userdefault.png';
    }

?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Alunos - <?php echo $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/alunosstyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Alunos</p>
                <p>Cadilag</p>
            </div>
            <div class='title'>
                <p><?= $title ?></p>
            </div> 
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="area">
            <button class="pure-button" onclick="window.location='./class.php?index=<?= $index ?>'">Voltar para a Turma</button>
            <div id="title"><p>Alunos vinculados á Turma (<?= count($alunos) ?>)</p></div>
            <?php
                foreach($alunos as $i=>$aluno):
                $title = $controlador->getTitleNameBy($aluno['nome'], $aluno['sobrenome'], $aluno['apelido'],$aluno['email']);
            ?>
                    <div id="<?= $i ?>" class="aluno">
                        <img src="<?= $aluno['image'].'?='.rand() ?>" alt="foto de <?= $title ?>"/>
                        <div class="title"><p><?= $title ?></p></div>
                        <div class="more"></div>
                    </div>
                    <div class="infos" id="<?= $i ?>" style="display:none;">
                        <div class="title"><p>Detalhes</p></div>
                        <label>Apelido</label><p><?= $aluno['apelido'] ?></p>
                        <label>Primeiro nome</label><p><?= $aluno['nome'] ?></p>
                        <label>Último nome</label><p><?= $aluno['sobrenome'] ?></p>
                        <label>Data de Cadastro</label><p><?= $aluno['data_cadastro'] ?></p> 
                        <?PHP if(!$isAluno): ?>
                        <div class="unbind">
                            <form action="./postDesvincularAluno.php" method="POST">
                                <input name="id" type="hidden" value="<?= $aluno['id'] ?>"/>
                                <input name="index" type="hidden" value="<?= $index ?>"/>
                                <div class="remove"><p>Desvincular da Turma</p></div>
                            </form>
                        </div>
                        <?PHP endif; ?>
                    </div>
            <?PHP endforeach; ?>
        </div>
        <?PHP include './includes/navbar.php';?>
        <script>
            
        $(".remove").click(function(){
            var obj = this;
            swal({   
                title: "Você tem certeza?",   
                text: "Você irá desvincular o aluno da turma!",   
                type: "warning",   
                showCancelButton: true,   
                confirmButtonColor: "#DD6B55",   
                confirmButtonText: "OK, Desvincular!",   
                closeOnConfirm: false }, 
                    function(){   
                       $(obj).parent().submit();
                    });
            
        });
        $(".aluno").click(function(){
            var id = $(this).attr('id');
            $(".more").removeAttr('selected');
            $(".infos").fadeOut(100);
            setTimeout(function(){
                $(".aluno[id='"+id+"'] .more").attr('selected','');
                $(".infos[id='"+id+"']").fadeIn(100);
            },101);
        });
        
        </script>
    </body>
</html>
