<!DOCTYPE html>
<?php
    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';

    $email = $_SESSION['email'];

    $controlador = new ControladorUsuario();
    $controlador->setUser($email);

    $imageurl = $controlador->getFilteredImage();
    $isAluno = $controlador->ehAluno();
    $title = $controlador->getTitleName();
    
    if(!$isAluno) {
        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();
        if(!$controlador->possuiAcesso()) {
            header("Location: class.php");
        }
    }
    include './entidades/Instituicao.php';
    include './entidades/Curso.php';
    include './controladores/Turma.php';
    include './entidades/Disciplina.php';
    $instituicoes = $controlador->listarInstituicoes();
    
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Vincular Turma - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/classmanagerstyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Vincular Turma</p>
                <p>Cadilag</p>
            </div>
            <div class='title'><p><?= $title; ?></p>
            </div> 
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class='descriptionbar'>
            <div class='description'><p>Instituição</p></div>
            <div class='description' style='width: 250px;'><p>Curso</p></div>
            <div class='description'><p>Disciplina</p></div>
            <div class='description' style='width: 235px;border-right:none;'><p>Turma</p></div>
        </div>
        <div class='area'>
            <div class='level' number='1'>
                <div class='subarea'>
                <?php foreach($instituicoes as $i=>$instituicao): ?>
                       <button class='optionl' subarea='<?= $instituicao->getId() ?>'>
                           <?= $instituicao->getNome() ?><br><b><?= $instituicao->getUf() ?></b>
                       </button>    
                <?php endforeach; ?>
                <?PHP if(!$isAluno): ?>
                    <form action="./createInstituicao.php">
                        <button class="optionl">Nova Instituição</button>
                    </form>
                <?php endif; ?>
                </div>
            </div>
            <div class='level' number='2'>
            <?PHP
                foreach($instituicoes as $i=>$instituicao): 
                    $cursos = $instituicao->getCursos();
                    if(!empty($cursos)):
                    ?>  
                        <div class='subarea' id='<?= $instituicao->getId() ?>' style='display:none;'>
                        <?PHP foreach($cursos as $j=>$curso): ?>
                            <button class="optionl" subarea="<?= $curso->getId() ?>"><?= $curso->getNome() ?><br><b><?= $curso->getSigla() ?></b></button>
                            <?PHP endforeach; if(!$isAluno): ?>    
                            <form action="./createCurso.php" method='POST'>
                                <input type='hidden' name='instid' value='<?= $instituicao->getId() ?>'/>
                                <button class="optionl">Novo Curso</button>
                            </form>
                            <?PHP endif; ?>
                        </div>
                    <?PHP else: ?>
                        <div class='subarea' id='<?= $instituicao->getId() ?>' style='display:none;'>
                            <?PHP if(!$isAluno): ?>
                            <form action="./createCurso.php" method='POST'>
                                <input type='hidden' name='instid' value='<?= $instituicao->getId() ?>'/>
                                <button class="optionl">Novo Curso</button>
                            </form>
                            <?PHP endif; ?>
                            <div class="vazio"><p>Vazio</p></div>
                        </div>   
            <?PHP endif; endforeach; ?>
            </div>
            <div class='level' number='3'>
            <?PHP
                foreach($instituicoes as $i=>$instituicao):
                    foreach($instituicao->getCursos() as $j=>$curso):
                        $disciplinas=$curso->getDisciplinas();?>
                        <div class='subarea' id='<?=$curso->getId()?>' style='display: none;'>
                        <?PHP if(!empty($disciplinas)): ?>
                            <?PHP foreach($disciplinas as $k=>$disciplina): ?>
                                <button class="optionl" subarea="<?= $disciplina->getId()?>"><?= $disciplina->getNome() ?></button>
                            <?PHP endforeach; if(!$isAluno): ?>
                                <form action="./createDisciplina.php" method='POST'>
                                    <input type='hidden' name='idcurso' value='<?= $curso->getId() ?>'/>
                                    <button class="optionl">Nova Disciplina</button>
                                </form>
                            <?PHP endif; ?>
                        <?PHP else: if(!$isAluno): ?>
                                <form action="./createDisciplina.php" method='POST'>
                                    <input type='hidden' name='idcurso' value='<?= $curso->getId() ?>'/>
                                    <button class="optionl">Nova Disciplina</button>
                                </form>
                            <?PHP endif; ?>
                                <div class="vazio"><p>Vazio</p></div>
                            <?PHP 
                        endif;?>
                        </div> <?PHP   
                    endforeach;
                endforeach;
            ?>
            </div>
            <div class='level' number='4' final='final'>
            <?PHP
                foreach($instituicoes as $i=>$instituicao):
                    foreach($instituicao->getCursos() as $j=>$curso):
                        foreach($curso->getDisciplinas() as $k=>$disciplina):
                            $turmas = $disciplina->getTurmas();        
                            if(count($turmas)!=0): ?>
                                <div class='subarea' id='<?= $disciplina->getId() ?>' style='display: none;'>
                                    <?PHP foreach($turmas as $m=>$turma): ?>
                                        <button class="optionl" subarea="<?=$turmas[$m]->getIdturma()?>"><?= $turmas[$m]->getAno() ?><br><?=($turmas[$m]->getSemestre()==1?'Primeiro':'Segundo')?> Semestre<finalbutton><br><br>Selecionar</finalbutton><selectedbutton><br>Selecionado</selectedbutton></button>    
                                    <?PHP endforeach; if(!$isAluno): ?>
                                        <form action="./createTurma.php" method='POST'>
                                            <input type='hidden' name='iddisc' value='<?= $disciplina->getId() ?>'/>
                                            <button class="optionl">Nova Turma</button>
                                        </form>
                                    <?PHP endif?>
                                </div>
                            <?PHP else: ?>
                            
                                <div class='subarea' id='<?= $disciplina->getId() ?>' style='display: none;'>
                                    <?PHP if(!$isAluno): ?>
                                        <form action="./createTurma.php" method='POST'>
                                            <input type='hidden' name='iddisc' value='<?= $disciplina->getId() ?>'/>
                                            <button class="optionl">Nova Turma</button>
                                        </form>
                                    <?PHP endif; ?>
                                    <div class="vazio"><p>Vazio</p></div>
                                </div>
                            <?PHP
                            endif;
                        endforeach;
                    endforeach;
                endforeach;
            ?>
        </div>
    </div>
        <?php foreach($controlador->listarTodasTurmas() as $turma): ?>
                
            <div class="infos" style="display:none" id="<?= $turma->getIdturma() ?>">
                <div class="title"><p>Status</p></div>
                <div class="description"><p><?= ($turma->getStatus()!==null && $turma->getStatus()!==''?$turma->getStatus():'Não definido') ?></p></div>
            </div>
            
        <?PHP endforeach; ?>
            <div class="buttonarea">
                <?PHP if($isAluno): ?>
                <form action="postSolicitacaoTurma.php" method="POST">
                    <input name="idturma" type="hidden"/>
                    <button class="pure-button" id="save" disabled>Solicitar</button>
                </form>
                <?PHP endif; ?>
                <button class="pure-button" id="cancel">Voltar</button>
            </div>
            <div class="dicas">
                <?PHP if(!$isAluno): ?>
                    <p>Crie uma nova turma através da instituição, curso, e disciplina existente. Caso não exista alguns desses itens, você pode criá-los;</p>
                <?PHP else: ?>
                    <p>1. Selecione a turma desejada através da instituição, curso, e disciplina;</p>
                    <p>2. Clique em Solicitar para obter acesso á turma.</p>      
                    <p>Obs.: Logo após a solicitação, o professor que criou a turma deve aceitar ou recursar a entrada, isso pode levar um tempo!</p>      
                <?PHP endif; ?>
            </div>
            <?PHP include './includes/navbar.php';?>
        <script>
            
            var dicas = $(".dicas");
            
            $("#cancel").click(function(){
                 window.location.replace("./class.php");
            });
            
            $(".level[final='final'] .optionl").click(function(){
                $("input[name='idturma']").val($(this).attr('subarea'));
                dicas.fadeOut(400);
                $(".infos").fadeOut(400);
                
                $(".infos[id='"+$(this).attr('subarea')+"']").fadeIn(400);
                $("#save").removeAttr('disabled');
            });
            
            $(".optionl").click(function(){
                
                if($(this).parent().parent().attr('final')!=='final'){
                    $(".infos").fadeOut(400);
                    $("#save").attr("disabled","");
                    dicas.fadeIn(400);
                }
                
                var subarea = $(this).attr('subarea');
                var level = parseInt($(this).parents(".level").attr('number'))+1;
                if($(this).attr('selected')!==undefined)
                {
                    $(this).removeAttr('selected');  
                    $(".level[number='"+level+"']  .subarea").fadeOut(200);
                    for(var i=level+1;i<5;i++)
                    {
                        $(".level[number='"+i+"']  .subarea").fadeOut(200);
                        $(".level[number='"+level+"']  .optionl").removeAttr('selected');
                    }
                    return;
                }
                
                $(".level[number='"+level+"']  .subarea").fadeOut(200);
                $(".level[number='"+(level-1)+"']  .optionl").removeAttr('selected');
                $(this).attr('selected','');
                setTimeout(function(){
                    $(".level[number='"+level+"']  .subarea[id='"+subarea+"']").fadeIn(200);
                    
                    for(var i=level+1;i<5;i++)
                    {
                        $(".level[number='"+i+"']  .subarea").fadeOut(200);
                            $(".level[number='"+level+"']  .optionl").removeAttr('selected');
                    }
                },200);
                
            });
        </script>

    </body>
</html>
