<?php

    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';

    $email = $_SESSION['email'];

    $controlador = new ControladorUsuario();
    $controlador->setUser($email);
    
    $isAluno = $controlador->ehAluno();
    $title = $controlador->getTitleName();
    
    if(!$isAluno) {
        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();
        if(!$controlador->possuiAcesso()) {
            header("Location: class.php");
        }
    } else {
        header("Location: class.php");
    }
    
    $imageurl = $controlador->getFilteredImage();

?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Nova instituição</title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/classmanagercreatestyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Nova instituição</p>
                <p>Cadilag</p>
            </div>
            
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="content">
            <div class="subtitle"><p>NOVA INSTITUIÇÃO</p></div>
            <div class="title"><p>Insira as informações abaixo</p></div>
            <form class="pure-form" method="POST" action="./postInstituicao.php">
                <div class="label">Nome</div>
                <input autocomplete="off" maxlength="100" placeholder="Exemplo: Unesp Júlio de Mesquita Filho" name="nome" type="text"/>
                <div class="label">UF</div>
                <select name="uf">
                    <option value="AC">Acre - AC</option>
                    <option value="AL">Alagoas - AL</option>
                    <option value="AM">Amazonas - AM</option>
                    <option value="AP">Amapá - AP</option>
                    <option value="BA">Bahia - BA</option>
                    <option value="CE">Ceará - CE</option>
                    <option value="DF">Distrito Federal - DF</option>
                    <option value="ES">Espírito Santo - ES</option>
                    <option value="GO">Goiás - GO</option>
                    <option value="MA">Maranhão - MA</option>
                    <option value="MT">Mato Grosso - MT</option>
                    <option value="MS">Mato Grosso do Sul - MS</option>
                    <option value="MG">Minas Gerais - MG</option>
                    <option value="PA">Pará - PA</option>
                    <option value="PB">Paraíba - PB</option>
                    <option value="PR">Paraná - PR</option>
                    <option value="PE">Pernambuco - PE</option>
                    <option value="PI">Piauí - PI</option>
                    <option value="RJ">Rio de Janeiro - RJ</option>
                    <option value="RN">Rio Grande do Norte - RN</option>
                    <option value="RS">Rio Grande do Su - RS</option>
                    <option value="RO">Rondônia - RO</option>
                    <option value="RR">Roraima - RR</option>
                    <option value="SC">Santa Catarina - SC</option>
                    <option value="SP" selected>São Paulo - SP</option>
                    <option value="SE">Sergipe - SE</option>
                    <option value="TO">Tocantins - TO</option>
                </select>
                <button class="pure-button pure-button-primary">Cadastrar</button>
                <button type="button" class="pure-button" onclick="window.location='./classmanager.php';">Voltar</button>
            </form>
        </div>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location='./profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location='./editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location='./arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location='./class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location='./novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location='./closesession.php';"><p>Sair</p></div>
        </div>
        <script>
            $("#gotohub").click(function(){
                $("#huboptions").fadeToggle(100); 
            });
        </script>
    </body>
</html>