<?php

session_start();

if (!isset($_SESSION['email']) ||
        !isset($_SESSION['senha'])) {
    echo json_encode(array("success" => false, "reply" => "Erro de Parametrização"));
}

include '../../../config/Database.php';
include '../controladores/PDOCadilag.php';
include '../controladores/CodePDO.php';
include '../controladores/ControladorCodigos.php';

$id = (int) (filter_input(INPUT_POST, 'idCode', FILTER_VALIDATE_INT));
if ($id) {
    $email = $_SESSION['email'];
    $password = $_SESSION['senha'];

    $controladorCode = new controladores\ControladorCodigos();

    if (!$controladorCode->checkAcess($email, $password)) {
        echo json_encode(array("success" => false, "reply" => "Erro de Sessão"));
        exit();
    }

    $result = $controladorCode->getCodes($id);
    if ($result['success']) {
        $jsonAdd = json_decode($result['add']);
        $jsonRem = json_decode($result['rem']);
        $jsonSearch = json_decode($result['search']);
        echo json_encode(array("addLines" => $jsonAdd, "remLines" => $jsonRem, "searchLines" => $jsonSearch, "success" => true));
    } else {
        echo json_encode(array("success" => false, "reply" => "Falha ao executar o script"));
    }
} else {
    echo json_encode(array("success" => false, "reply" => "Falha de Filtro"));
}