<?php

session_start();

if (!isset($_SESSION['email']) ||
        !isset($_SESSION['senha']) ||
        !isset($_POST['descricao']) ||
        !isset($_POST['idestrutura']) ||
        !isset($_POST['historico'])) {
    echo json_encode(array("success" => false, "reply" => "Erro de Parametrização"));
    exit();
}

include '../../../config/Database.php';
include '../controladores/PDOCadilag.php';
include '../controladores/ReportPDO.php';
include '../controladores/ControladorReport.php';

$descricao = filter_input(INPUT_POST, 'descricao', FILTER_SANITIZE_STRING);
$historico = filter_input(INPUT_POST, 'historico', FILTER_SANITIZE_STRING);
$idestrutura = (int) (filter_input(INPUT_POST, 'idestrutura', FILTER_VALIDATE_INT));

if($descricao && $historico && $idestrutura){
    $email = $_SESSION['email'];
    $password = $_SESSION['senha'];

    $controladorReport = new controladores\ControladorReport();

    if (!$controladorReport->checkAcess($email, $password)) {
        echo json_encode(array("success" => false, "reply" => "Erro de Sessão"));
        exit();
    }

    $resultSQL = $controladorReport->insertReport($idestrutura, $descricao, $historico);
    echo json_encode($resultSQL);
} else {
    echo json_encode(array("success" => false, "reply" => "Falha de Filtro"));
}