<?php

namespace controladores;

use PDO;
use config\Database;

class ControladorReport {

    private $connection;

    public function __construct() {
        try {
            $this->connection = new ReportPDO(
                    'mysql:host=localhost;dbname=' . Database::$mysql_dbname, Database::$mysql_user, Database::$mysql_password
            );
        } catch (PDOException $e) {
            echo '<code>' . $e->getMessage() . '</code>';
            die();
        }
    }

    public function checkAcess($email, $password) {
        return $this->connection->checkAcess($email, $password);
    }


    public function insertReport($idEstrutura, $text, $json) {
        try {
            $stmt = $this->connection->insertStmt($idEstrutura, $text, $json);
            $resultPDO = $stmt->execute();
            return array("success" => $resultPDO, "resultSQL" => $resultPDO);
        } catch (PDOException $e) {
            echo $e->getMessage();
        }
        return array("success" => false, "reply" => $e->getMessage());
    }


}
