<?php

namespace controladores;

use controladores\PDOCadilag;
use PDO;

class EpPDO extends PDOCadilag {

    public function getJsonStmt($idEp) {
        $stmt = $this->prepare('SELECT descricao,json,Estrutura_De_Dado_ed_id ' .
                        'FROM entradaprogramada ' .
                        'WHERE `Usuario_usu_id` = :idUser' .
                        ' AND `idEntradaProgramada` = :idEp');
        $stmt->bindValue(':idUser', $this->idUser, PDO::PARAM_INT);
        $stmt->bindValue(':idEp', $idEp, PDO::PARAM_INT);
        return $stmt;
    }

    public function insertStmt($idEstrutura, $rotulo, $totalEp, $json) {
        $stmt = $this->prepare(
                        'INSERT INTO entradaprogramada(`Usuario_usu_id`,`Estrutura_De_Dado_ed_id`,descricao,totalep,json,`data`,hora) '
                        . 'VALUES (:iduser,:idestrutura,:rotulo,:total,:json,current_date(),current_time())');
        $stmt->bindParam(':iduser', $this->idUser, PDO::PARAM_INT);
        $stmt->bindParam(':idestrutura', $idEstrutura, PDO::PARAM_INT);
        $stmt->bindParam(':rotulo', $rotulo, PDO::PARAM_STR);
        $stmt->bindParam(':total', $totalEp, PDO::PARAM_INT);
        $stmt->bindParam(':json', $json, PDO::PARAM_STR);
        return $stmt;
    }

    public function listaStmt($idEstrutura) {
        $stmt = $this->prepare('SELECT ' .
                        'idEntradaProgramada as id, ' .
                        'descricao as rotulo, ' .
                        'DATE_FORMAT(data, "%d/%m/%Y") as data, ' .
                        'hora as hora, ' .
                        'totalep as total ' .
                        'FROM entradaprogramada ' .
                        'WHERE `Usuario_usu_id` = :idUser' .
                        ' AND `Estrutura_De_Dado_ed_id` = :idStruct');
        $stmt->bindValue(':idUser', $this->idUser, PDO::PARAM_INT);
        $stmt->bindValue(':idStruct', $idEstrutura, PDO::PARAM_INT);
        return $stmt;
    }

    public function deleteStmt($idEp) {
        $stmt = $this->prepare('DELETE FROM entradaprogramada' .
                        ' WHERE `Usuario_usu_id` = :idUser' .
                        ' AND `idEntradaProgramada` = :idEp');
        $stmt->bindValue(':idUser', $this->idUser, PDO::PARAM_INT);
        $stmt->bindValue(':idEp', $idEp, PDO::PARAM_INT);
        return $stmt;
    }

    public function descriptionStmt($idEp) {
        $stmt = $this->prepare('SELECT ' .
                        'descricao as rotulo, ' .
                        'DATE_FORMAT(data, "%d/%m/%Y") as data, ' .
                        'hora as hora ' .
                        'FROM entradaprogramada ' .
                        'WHERE `Usuario_usu_id` = :idUser ' .
                        'AND `idEntradaProgramada` = :idEp');
        $stmt->bindValue(':idUser', $this->idUser, PDO::PARAM_INT);
        $stmt->bindValue(':idEp', $idEp, PDO::PARAM_INT);
        return $stmt;
    }

    public function updateStmt($rotulo, $idEp, $total, $json) {
        $stmt = $this->prepare('UPDATE entradaprogramada SET '
                        . 'descricao = :rotulo,json = :json , totalep = :total, '
                        . 'hora = current_time(),`data` = current_date() '
                        . 'WHERE `idEntradaProgramada` = :idep AND `Usuario_usu_id` = :usuid');
        $stmt->bindValue(':rotulo', $rotulo, PDO::PARAM_STR);
        $stmt->bindValue(':idep', $idEp, PDO::PARAM_INT);
        $stmt->bindValue(':usuid', $this->idUser, PDO::PARAM_INT);
        $stmt->bindValue(':total', $total, PDO::PARAM_INT);
        $stmt->bindValue(':json', $json, PDO::PARAM_STR);
        return $stmt;
    }

}
