jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function AVL() {
    this.raiz = null;
    this.MENOR = null;
    this.MAIOR = null;
    this.queue = null;

    AVL.criaNo = function () {
        return {ref: null, id: null, value: null, esq: null, dir: null};
    };

    AVL.criaRef = function () {
        return {ref: null};
    };

    this.inicia = function () {
        this.raiz = AVL.criaRef();
        this.raiz.ref = AVL.criaNo();
        this.id_rotacao = 0;
        this.queue = [];
    };

    this.altura = function (no) {
        if (!no.ref.ref)
            return -1;

        var esq = this.altura(no.ref.esq) + 1;
        var dir = this.altura(no.ref.dir) + 1;

        return esq > dir ? esq : dir;
    };

    this.fatorBalanceamento = function (no) {
        return this.altura(no.ref.dir) - this.altura(no.ref.esq);
    };

    this.rotacaoEsquerda = function (pai, no) {
        var q = no.ref.dir;
        var temp = q.ref.esq;

        q.ref.esq = no;
        no.ref.dir = temp;
        if (pai != null) {
            if (pai.ref.dir == no)
                pai.ref.dir = q;
            else
                pai.ref.esq = q;
        } else
            this.raiz = q;
    };

    this.rotacaoDireita = function (pai, no) {
        var q = no.ref.esq;
        var temp = q.ref.dir;

        q.ref.dir = no;
        no.ref.esq = temp;

        if (pai != null) {
            if (pai.ref.dir == no)
                pai.ref.dir = q;
            else
                pai.ref.esq = q;
        } else
            this.raiz = q;
    };

    this.rotacaoEsquerdaDireita = function (pai, no) {
        this.rotacaoEsquerda(no, no.ref.esq);
        this.rotacaoDireita(pai, no);
    };

    this.rotacaoDireitaEsquerda = function (pai, no) {
        this.rotacaoDireita(no, no.ref.dir);
        this.rotacaoEsquerda(pai, no);
    };

    this.verifica = function (pai, raiz) {
        var balRaiz = this.fatorBalanceamento(raiz);

        if (balRaiz > 0) {
            if (this.fatorBalanceamento(raiz.ref.dir) > 0) {
                this.queue.push({p: pai, avo: raiz, pai: raiz.ref.dir, filho: raiz.ref.dir.ref.dir, id_rotacao: 1});
                this.rotacaoEsquerda(pai, raiz);
            } else {
                this.queue.push({p: pai, avo: raiz, pai: raiz.ref.dir, filho: raiz.ref.dir.ref.esq, id_rotacao: 2});
                this.queue.push({p: pai, avo: raiz, pai: raiz.ref.dir.ref.esq, filho: raiz.ref.dir, id_rotacao: 1});
                this.rotacaoDireitaEsquerda(pai, raiz);
            }
        } else {
            if (this.fatorBalanceamento(raiz.ref.esq) < 0) {
                this.queue.push({p: pai, avo: raiz, pai: raiz.ref.esq, filho: raiz.ref.esq.ref.esq, id_rotacao: 3});
                this.rotacaoDireita(pai, raiz);
            } else {
                this.queue.push({p: pai, avo: raiz, pai: raiz.ref.esq, filho: raiz.ref.esq.ref.dir, id_rotacao: 4});
                this.queue.push({p: pai, avo: raiz, pai: raiz.ref.esq.ref.dir, filho: raiz.ref.esq, id_rotacao: 3});
                this.rotacaoEsquerdaDireita(pai, raiz);
            }
        }
    };

    this.insere2 = function (raiz, pai, elem) {
        if (raiz.ref.ref == null) {

            if (this.MENOR == null && this.MAIOR == null) {
                this.MENOR = elem.valor;
                this.MAIOR = elem.valor;
            } else {
                if (parseInt(this.MENOR) > parseInt(elem.valor))
                    this.MENOR = elem.valor;
                if (parseInt(this.MAIOR) < parseInt(elem.valor))
                    this.MAIOR = elem.valor;
            }


            var noEsq = AVL.criaRef();
            var noDir = AVL.criaRef();
            noEsq.ref = AVL.criaNo();
            noDir.ref = AVL.criaNo();
            raiz.ref.ref = elem.d;
            raiz.ref.id = elem.id;
            raiz.ref.value = elem.valor;
            raiz.ref.esq = noEsq;
            raiz.ref.dir = noDir;
            Element.bind(raiz.ref,raiz.ref.id);

        } else if (parseInt(raiz.ref.value) < parseInt(elem.valor)) {
            this.insere2(raiz.ref.dir, raiz, elem);
            if (Math.abs(this.fatorBalanceamento(raiz)) >= 2)
                this.verifica(pai, raiz);
        } else if (parseInt(raiz.ref.value) > parseInt(elem.valor)) {
            this.insere2(raiz.ref.esq, raiz, elem);
            if (Math.abs(this.fatorBalanceamento(raiz)) >= 2)
                this.verifica(pai, raiz);
        }
    };

    this.insere = function (elem) {
        this.insere2(this.raiz, null, elem);
    };

    this.search2 = function (raiz, value) {
        if (raiz.ref.ref == null)
            return null;
        if (parseInt(raiz.ref.value) == parseInt(value))
            return raiz;
        else if (parseInt(raiz.ref.value) < parseInt(value))
            return this.search2(raiz.ref.dir, value);
        else
            return this.search2(raiz.ref.esq, value);
    };

    this.search = function (value) {
        return this.search2(this.raiz, value);
    };

    this.remocao2 = function (raiz, pai, value) {
        if (raiz.ref.ref != null) {
            if (parseInt(raiz.ref.value) < parseInt(value)) {
                this.remocao2(raiz.ref.dir, raiz, value);
                if (Math.abs(this.fatorBalanceamento(raiz)) >= 2)
                    this.verifica(pai, raiz);
            } else if (parseInt(raiz.ref.value) > value) {
                this.remocao2(raiz.ref.esq, raiz, value);
                if (Math.abs(this.fatorBalanceamento(raiz)) >= 2)
                    this.verifica(pai, raiz);
            } else {
                if (raiz.ref.dir.ref.ref == null)
                    raiz.ref = raiz.ref.esq.ref;
                else if (raiz.ref.esq.ref.ref == null)
                    raiz.ref = raiz.ref.dir.ref;
                else {
                    this.removeSucessor(raiz, raiz.ref.dir, raiz);
                    if (Math.abs(this.fatorBalanceamento(raiz)) >= 2)
                        this.verifica(pai, raiz);
                }
            }
        }
    };

    this.removeSucessor = function (q, p, pai) {
        if (p.ref.esq.ref.ref == null) {
            q.ref.value = p.ref.value;
            q.ref.ref = p.ref.ref;

            p.ref = p.ref.dir.ref;
        } else {
            this.removeSucessor(q, p.ref.esq, p);
            if (Math.abs(this.fatorBalanceamento(raiz)) >= 2)
                this.verifica(pai, raiz);
        }
    };

    this.remove = function (value) {
        this.remocao2(this.raiz, null, value);
    };

    this.show = function (raiz) {
        if (raiz.ref.ref != null) {
            this.show(raiz.ref.esq);
            alert(raiz.ref.value);
            this.show(raiz.ref.dir);
        }
    };

    this.maisEsquerdo = function (raiz) {
        if (raiz.ref.esq.ref.ref == null) {
            return raiz;
        } else
            return this.maisEsquerdo(raiz.ref.esq);
    };

    this.getSucessor = function (raiz) {
        return this.maisEsquerdo(raiz.ref.dir);
    };

    this.resetRotacao = function () {
        this.queue = [];
    };

    this.getRotacao = function () {
        return this.queue.shift();
    };

}

(function () {
    var collection = new AVL();

    var 
    animationRotacaoEsquerda = function (p, avo, pai, filho, temp) {

        var speed = getSpeed();
        var dif = parseInt(pai.ref.ref.style.left) - (parseInt(avo.ref.ref.style.left));

        var posAvo = {left: parseInt(avo.ref.ref.style.left), top: parseInt(avo.ref.ref.style.top)};
        var posPai = {left: parseInt(pai.ref.ref.style.left), top: parseInt(pai.ref.ref.style.top)};
        Plumb.moveTo(avo.ref.id,posAvo.left - dif,posPai.top,2000*speed);
        Plumb.moveTo(pai.ref.id, posAvo.left, posAvo.top, 2000 * speed);

        if (p != null) {
            disconnectDisc(p, avo, null);
            connectDisc2(p, pai);
        }

        if (filho != null)
            Plumb.moveTo(filho.ref.id,posPai.left, posPai.top, 2000 * speed);
        else {
            disconnectDisc(temp, avo);
            connectDisc2(temp, pai);
        }

        if (avo.ref.dir.ref.ref != null) {
            connectDisc2(avo, avo.ref.dir);
            disconnectDisc(pai, avo.ref.dir, null);
        }

        disconnectDisc(avo, pai, null);
        connectDisc2(pai, avo);
    },
    animationRotacaoDireita = function (p, avo, pai, filho, temp) {
        var speed = getSpeed();
        var dif = parseInt(avo.ref.ref.style.left) - parseInt(pai.ref.ref.style.left);
        var posAvo = {left: parseInt(avo.ref.ref.style.left), top: parseInt(avo.ref.ref.style.top)};
        var posPai = {left: parseInt(pai.ref.ref.style.left), top: parseInt(pai.ref.ref.style.top)};

        Plumb.moveTo(avo.ref.id, posAvo.left + dif,posPai.top,  2000 * speed);
        Plumb.moveTo(pai.ref.id, posAvo.left, posAvo.top, 2000 * speed);

        if (p != null) {
            disconnectDisc(p, avo, null);
            connectDisc2(p, pai);
        }

        if (filho != null)
            Plumb.moveTo(filho.ref.id, posPai.left, posPai.top,2000 * speed);
        else {
            disconnectDisc(temp, avo);
            connectDisc2(temp, pai);
        }

        if (avo.ref.esq.ref.ref != null) {
            connectDisc2(avo, avo.ref.esq);
            disconnectDisc(pai, avo.ref.esq, null);
        }


        disconnectDisc(avo, pai, null);
        connectDisc2(pai, avo);
    },
    getParent = function (raiz, elem) {
        if (parseInt(raiz.ref.value) == parseInt(elem.ref.value))
            return null;

        var temp = raiz;
        while (temp.ref.ref != null && temp.ref.dir != elem && temp.ref.esq != elem) {
            if (parseInt(elem.ref.value) < parseInt(temp.ref.value))
                temp = temp.ref.esq;
            else
                temp = temp.ref.dir;
        }

        if (temp.ref.ref == null)
            return null;

        return temp;
    },


    organizaArvoreEsquerda = function (raiz, value, dif) {
        var speed = getSpeed();
        if (raiz.ref.ref != null) {
            if (parseInt(raiz.ref.value) > parseInt(value)) {
                var pos = {left: parseInt(raiz.ref.ref.style.left), top: parseInt(raiz.ref.ref.style.top)};
                Plumb.moveTo(raiz.ref.id,pos.left + dif, pos.top, 2000 * speed);
            }
            organizaArvoreEsquerda(raiz.ref.esq, value, dif);
            organizaArvoreEsquerda(raiz.ref.dir, value, dif);

        }
    },
    organizaArvoreDireita = function (raiz, value, dif) {
        var speed = getSpeed();
        if (raiz.ref.ref != null) {
            if (parseInt(raiz.ref.value) >= parseInt(value)) {
                var pos = {left: parseInt(raiz.ref.ref.style.left), top: parseInt(raiz.ref.ref.style.top)};
                Plumb.moveTo(raiz.ref.id,  pos.left + dif,pos.top, 2000 * speed);
            }
            organizaArvoreDireita(raiz.ref.esq, value, dif);
            organizaArvoreDireita(raiz.ref.dir, value, dif);

        }
    },
    remanejarArvore = function (raiz, pai, i, pos) {
        var speed = getSpeed();
        if (raiz.ref.ref != null) {
            pos = {left: pos.left + (i == 0 ? 0 : (pai != null && parseInt(pai.ref.value) > parseInt(raiz.ref.value) ? -250 / i : 250 / i)),
                top: pos.top + (i != 0 ? 50 : 0)};
            Plumb.moveTo(raiz.ref.id, pos.left,pos.top,2000 * speed);
            i++;
            remanejarArvore(raiz.ref.esq, raiz, i, pos);
            remanejarArvore(raiz.ref.dir, raiz, i, pos);
        }
    },
    animationAdd = function (info) {
        UI.lock();
        collection.resetRotacao();
        var pai = null;
        var raiz = collection.raiz;
        var pos = {left: 500, top: 75};
        var i = 0;
        var j = 0;
        var speed = getSpeed();

        while (raiz.ref.ref != null) {
            pos = {left: parseInt(raiz.ref.ref.style.left), top: parseInt(raiz.ref.ref.style.top)};
            Plumb.moveTo(info.id, pos.left,pos.top + 40, 2000 * speed);
            pai = raiz;

            if (parseInt(info.valor) < parseInt(raiz.ref.value))
                raiz = raiz.ref.esq;
            else if (parseInt(info.valor) > parseInt(raiz.ref.value))
                raiz = raiz.ref.dir;
            else
            {
                setTimeout(function(){
                    $("#"+info.id).fadeOut(1000*speed,function(){
                        $("#"+info.id).remove();
                        UI.unlock();
                        window.Eprogramada.nextQueue();
                    });    
                },2000*speed*i);
                return;                            
            }
            i++;
            j++;
        }

        setTimeout(function () {
            if (pai != null) {
                if (parseInt(pai.ref.value) < parseInt(info.valor)) {
                    Plumb.moveTo(info.id, pos.left + 250 / i, pos.top + 50, 2000 * speed);
                    connectDisc(pai, info);
                } else if (parseInt(pai.ref.value) > parseInt(info.valor)) {
                    var diferenca = pos.left - 250 / i;

                    if (pos.left - 250 / i < 0) {
                        var diferenca = Math.abs(pos.left - 250 / i);
                        organizaArvoreDireita(collection.raiz, pai.ref.value, diferenca);
                        diferenca = 0;
                        i++;
                    }

                    Plumb.moveTo(info.id,  diferenca, pos.top + 50,2000 * speed);
                    connectDisc(pai, info);

                }

                i++;
            } else
                Plumb.moveTo(info.id,pos.left,pos.top,2000*speed);
        }, j * 2000 * speed);


        setTimeout(function () {
            collection.insere(info);
            var temp = null;
            var aux = 0;
            while ((temp = collection.getRotacao()) && temp != null) {
                aux++;
                if (temp.id_rotacao == 1)
                    animationRotacaoEsquerda(temp.p, temp.avo, temp.pai, temp.filho, null);
                if (temp.id_rotacao == 2)
                    animationRotacaoDireita(null, temp.pai, temp.filho, null, temp.avo);
                if (temp.id_rotacao == 3)
                    animationRotacaoDireita(temp.p, temp.avo, temp.pai, temp.filho, null);
                if (temp.id_rotacao == 4)
                    animationRotacaoEsquerda(null, temp.pai, temp.filho, null, temp.avo);
            }
            UI.unlock();
            setTimeout(function () {
                remanejarArvore(collection.raiz, null, 0, {left: 500, top: 75});
                window.Eprogramada.nextQueue();
            }, aux * 2000 * speed);

        }, (i + 1) * 2000 * speed);
    },
    animationSearch = function (info) {

        UI.lock();
        var speed = getSpeed();
        var raiz = collection.raiz;
        var j = 0;

        while (raiz.ref.ref != null) {
            Plumb.moveTo(info.id,parseInt(raiz.ref.ref.style.left), parseInt(raiz.ref.ref.style.top) + 40,2000 * speed);

            if (parseInt(info.valor) < parseInt(raiz.ref.value))
                raiz = raiz.ref.esq;
            else if (parseInt(info.valor) > parseInt(raiz.ref.value))
                raiz = raiz.ref.dir;
            else
                break;
            j++;

        }

        setTimeout(function () {
            $("#" + info.id).fadeOut(1000 * speed);
            if (raiz.ref.ref != null) {
                var obj = $("#" + raiz.ref.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            }

            setTimeout(function () {
                $("#" + info.id).remove();
                UI.unlock();
            }, 1200 * speed);
        }, j * 2000 * speed + 1000 * speed);

    },
    animationRemove = function (info) {
        UI.lock();
        var value = info.valor;
        var raiz = collection.raiz;
        var pos = {left: 500, top: 75};
        var j = 0;
        var speed = getSpeed();

        while (raiz.ref.ref != null) {
            pos = {left: parseInt(raiz.ref.ref.style.left), top: parseInt(raiz.ref.ref.style.top)};
            Plumb.moveTo(info.id, pos.left,pos.top, 2000 * speed);

            if (parseInt(info.valor) < parseInt(raiz.ref.value))
                raiz = raiz.ref.esq;
            else if (parseInt(info.valor) > parseInt(raiz.ref.value))
                raiz = raiz.ref.dir;
            else
                break;
            j++;
        }

        if(raiz.ref.ref==null)
        {
            setTimeout(function(){
            $("#"+info.id).fadeOut(1000*speed,function(){
                $("#"+info.id).remove();
                UI.unlock();
                window.Eprogramada.nextQueue();
            });    
            },2000*speed*j);
            return;      
        }

        setTimeout(function () {
            $("#" + info.id).fadeOut(1000 * speed);

            if (raiz.ref.ref != null) {
                var objRaiz = $("#" + raiz.ref.id);
                objRaiz.fadeOut(1000 * speed);
                objRaiz.fadeIn(1000 * speed);
                objRaiz.fadeOut(1000 * speed);
                objRaiz.fadeIn(1000 * speed);
                objRaiz.fadeOut(1000 * speed);
                objRaiz.fadeIn(1000 * speed);

                if (raiz.ref.dir.ref.ref != null && raiz.ref.esq.ref.ref != null) {
                    var sucessor = collection.getSucessor(raiz);
                    var obj = $("#" + sucessor.ref.id);
                    obj.fadeOut(1000 * speed);
                    obj.fadeIn(1000 * speed);
                    obj.fadeOut(1000 * speed);
                    objfadeIn(1000 * speed);
                    obj.fadeOut(1000 * speed);
                    obj.fadeIn(1000 * speed);

                    setTimeout(function () {
                        objRaiz.remove(".itemValue");
                        objRaiz.html("<span class='itemValue' style='top:7px'>" + sucessor.ref.value + "</span>");
                        raiz = sucessor;
                    }, 6000 * speed);

                }

                setTimeout(function () {
                    var pai = getParent(collection.raiz, raiz);
                    if (raiz.ref.dir.ref.ref == null && raiz.ref.esq.ref.ref == null) {
                        if (pai != null) {

                            Plumb.moveTo(raiz.ref.id, parseInt(pai.ref.ref.style.left),parseInt(pai.ref.ref.style.top),2000 * speed);
                            setTimeout(function () {
                                disconnectDisc(pai, raiz, null);
                            }, 2000 * speed);
                        }
                    } else if (raiz.ref.dir.ref.ref != null) {
                        var dir = raiz.ref.dir;
                        Plumb.moveTo(dir.ref.id, parseInt(raiz.ref.ref.style.left),parseInt(raiz.ref.ref.style.top),2000 * speed);
                        setTimeout(function () {
                            disconnectDisc(pai, raiz, dir);
                        }, 2000 * speed);


                    } else {
                        var esq = raiz.ref.esq;
                        Plumb.moveTo(esq.ref.id, parseInt(raiz.ref.ref.style.left),parseInt(raiz.ref.ref.style.top),2000 * speed);
                        setTimeout(function () {
                            disconnectDisc(pai, raiz, esq);
                        }, 2000 * speed);
                    }
                }, 6100 * speed);


                setTimeout(function () {
                    $("#" + raiz.ref.id).remove();
                    collection.remove(value);
                    UI.unlock();
                }, 9000 * speed);

            }

            setTimeout(function () {
                $("#" + info.id).remove();
            }, 1500 * speed);

            setTimeout(function () {
                var temp = null;
                var aux = 0;
                while ((temp = collection.getRotacao()) && temp != null) {
                    aux++;
                    if (temp.id_rotacao == 1)
                        animationRotacaoEsquerda(temp.p, temp.avo, temp.pai, temp.filho, null);
                    if (temp.id_rotacao == 2)
                        animationRotacaoDireita(null, temp.pai, temp.filho, null, temp.avo);
                    if (temp.id_rotacao == 3)
                        animationRotacaoDireita(temp.p, temp.avo, temp.pai, temp.filho, null);
                    if (temp.id_rotacao == 4)
                        animationRotacaoEsquerda(null, temp.pai, temp.filho, null, temp.avo);
                }
                UI.unlock();
                setTimeout(function () {
                    remanejarArvore(collection.raiz, null, 0, {left: 500, top: 75});
                    window.Eprogramada.nextQueue();
                }, aux * 2000 * speed);

            }, 10000 * speed);

        }, j * 2000 * speed + 1000 * speed);

    },
    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isTarget:false,isSource:true,isPrimary:true,anchor:"Top"});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isTarget:false,isSource:true,isPrimary:false,anchor:"Top"});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isTarget:true,isSource:false,isPrimary:true,anchor:[1, 0.8, 0, -1]});
    },
    prepare4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isTarget:true,isSource:false,isPrimary:false,anchor:[0, 0.8, 0, -1]});
    },
    connectDisc2 = function (pai, elem) {
        if (pai != null) {
            if (parseInt(pai.ref.value) < parseInt(elem.ref.value))
                Plumb.conectar(prepare3(pai.ref.id), prepare(elem.ref.id));
            else
                Plumb.conectar(prepare4(pai.ref.id),prepare2(elem.ref.id));
        }
    },
    connectDisc = function (pai, elem) {
        if (pai != null) {
            if (parseInt(pai.ref.value) < parseInt(elem.valor))
                Plumb.conectar(prepare3(pai.ref.id),prepare(elem.id));
            else
                Plumb.conectar(prepare4(pai.ref.id),prepare2(elem.id));
        }
    },
    disconnectDisc = function (pai, filho, neto) {
        if (neto != null) {
            var connections = jsPlumb.getConnections({target: filho.ref.id});
            if (connections[0] != "undefined")
                jsPlumb.detach(connections[0]);

            connections = jsPlumb.getConnections({target: neto.ref.id});
            if (connections[0] != "undefined")
                jsPlumb.detach(connections[0]);


            if (parseInt(pai.ref.value) < parseInt(neto.ref.value))
                Plumb.conectar(prepare3(pai.ref.id),prepare(neto.ref.id));
            else
                Plumb.conectar(prepare4(pai.ref.id),prepare2(neto.ref.id));

        } else {

            var connections = jsPlumb.getConnections({target: filho.ref.id});
            if (connections[0] != "undefined")
                jsPlumb.detach(connections[0]);
        }


    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicSmallDot altColor",
            innerHTML:"<span class='itemValue altColorTitle' style='top: 7px'>" + value + "</span>",
            left:"0px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.setProperty("primaryColorProperty",true);
            collection.inicia();
            UI.InitInterface(this.search,this.elementToString);
        },
        elementToString: function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.value};
                if (element.esq.ref.ref !== null) {
                    var nextId = (element.esq.ref.id * 1).toString(16).toUpperCase();
                    result.esquerda = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.esquerda = 'null';
                if (element.dir.ref.ref !== null) {
                    var nextId = (element.dir.ref.id * 1).toString(16).toUpperCase();
                    result.direita = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.direita = 'null';
                return result;
            }
            return false;
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicSmallDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor','Insira apenas números inteiros');
                if(value!=="") {
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    var info = createDisc(value);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {

            var value = UI.value('valor','Insira apenas números inteiros');
            if(value!=="") {
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationRemove(info);
            }

        },
        searchValue: function () {
            var value = UI.value('valor','Insira apenas números inteiros');
            if(value!=="") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }

    };
})();

