
function NoElem() {
	this.pai = null;
	this.esq = null;
	this.dir = null;
	this.chave = null;
	this.cor = null;
	this.id = null;
	this.ref = null;
};

function NoNil() {
	this.pai = null;
};

function NoRN() {
	this.nil = null;
	this.no = null;
};

function RN() {
	this.raiz = null;
	this.RUBRO = false;
	this.NEGRO = true;

	this.inicia = function() {
		this.raiz = new NoRN();
		this.raiz.nil = true;
		this.raiz.no = new NoNil();
		this.raiz.no.pai = null;
	}

	this.insere = function(no, pai, elem) {
		if( no.nil ) {
			var novo1 = new NoRN();
			var novo2 = new NoRN();
			no.no = new NoElem();

			if( novo1 && novo2 && no.no ) {
				novo1.no = new NoNil();
				novo1.nil = true;
				novo2.nil = true;
				novo2.no = new NoNil();
				no.nil = false;

				if( novo1.no && novo2.no ) {
					novo2.no.pai = no;
					novo1.no.pai = no;
					no.no.pai = pai;

					if( pai && pai.no.dir == no ) 
						pai.no.dir = no;
					else if( pai )
						pai.no.esq = no;
				
					no.no.esq = novo1;
					no.no.dir = novo2;
				
					no.no.chave = elem.valor;
					no.no.cor = this.RUBRO;
					no.no.id = elem.id;
					no.no.ref = elem.ref;


					return no;
				}
			}

			return null;
		} else if( no.no.chave > elem.valor )
			return this.insere(no.no.esq, no, elem);
		else if( no.no.chave < elem.valor )
			return this.insere(no.no.dir, no, elem);
		else
			return null;
	}

	this.inserir = function(elem) {
		var q = this.insere(this.raiz, null, elem);		
		this.remanejarInsercao(this.raiz, q);
	}

	this.leftRotation = function(raiz, x) {
		var y = x.no.dir;

		x.no.dir = y.no.esq;
		y.no.esq.no.pai = x;

		var pai = x.no.pai;

		if( !x.no.pai )
			raiz = y;
		else {
			if( x == x.no.pai.no.esq )
				x.no.pai.no.esq = y;
			else
				x.no.pai.no.dir = y;
		}	

		y.no.esq = x;
		x.no.pai = y;
		y.no.pai = pai;
	}

	this.rightRotation = function(raiz, x) {
		var y = x.no.esq;

		x.no.esq = y.no.dir;
		y.no.dir.no.pai = x;

		var pai = x.no.pai;

		if( !x.no.pai )
			raiz = y;
		else {
			if( x == x.no.pai.no.esq )
				x.no.pai.no.esq = y;
			else
				x.no.pai.no.dir = y;
		}

		y.no.dir = x;
		x.no.pai = y;
		y.no.pai = pai;
	}

	this.remanejarInsercao = function(raiz, z) {
		
		while( z.no.pai && z.no.pai.no.cor == this.RUBRO ) {
			if( z.no.pai == z.no.pai.no.pai.no.esq ) {
				var y = z.no.pai.no.pai.no.dir;

				if( !y.nil && y.no.cor == this.RUBRO ) {
					z.no.pai.no.cor = this.NEGRO;
					y.no.cor = this.NEGRO;
					z.no.pai.no.pai.no.cor = this.RUBRO;
					z = z.no.pai.no.pai;
				} else {

					if( z == z.no.pai.no.dir ) {
						z = z.no.pai;
						this.leftRotation(raiz, z);
					}

					z.no.pai.no.cor = this.NEGRO;
					z.no.pai.no.pai.no.cor = this.RUBRO;
					this.rightRotation(raiz, z.no.pai.no.pai);
				}
			} else {
				var y = z.no.pai.no.pai.no.esq;

				if( !y.nil && y.no.cor == this.RUBRO) {
					z.no.pai.no.cor = this.NEGRO;
					y.no.cor = this.NEGRO;
					z.no.pai.no.pai.no.cor = this.RUBRO;
					z = z.no.pai.no.pai;
				} else {

					if( z == z.no.pai.no.esq ) {
						z = z.no.pai;
						this.rightRotation(raiz, z);						
					}

					z.no.pai.no.cor = this.NEGRO;
					z.no.pai.no.pai.no.cor = this.RUBRO;
					this.leftRotation(raiz, z.no.pai.no.pai);
				}
			}

		}

		if( raiz ) {
			raiz.no.cor = this.NEGRO;
			raiz.nil = false;
		}
	}

	this.removeAux = function(r, filho, chave, preto) {
		if( !r.nil ) {
			if( r.no.chave > chave ) 
				this.removeAux(r.no.esq, filho, chave, preto);
			else if( r.no.chave < chave )
				this.removeAux(r.no.dir, filho, chave, preto);
			else {
				if( r.no.esq.nil ) {
					
					if( r.no.cor == this.NEGRO )
						preto.cor = true;
					filho.obj = r.no.dir;
					r.no.dir.no.pai = r.no.pai;

					var q = r.no.dir.nil;
					r.no = r.no.dir.no;
					r.nil = q;
				} else if( r.no.dir.nil ) {
					

					if( r.no.cor == this.NEGRO )
						preto.cor = true;
					filho.obj = r.no.esq;
					r.no.esq.no.pai = r.no.pai;
					
					var q = r.no.esq.nil;
					r.no = r.no.esq.no;					
					r.nil = q;
				} else
					this.removeSucessor(r, r.no.dir, preto, filho);
			}
		}
	}

	this.removeSucessor = function(q, p, preto, filho) {
		if( p.no.esq.nil == this.NEGRO ) {

			if( p.no.cor == this.NEGRO )
				preto.cor = true;
			filho.obj = p.no.dir;

			p.no.dir.no.pai = p.no.pai;
			q.no.id = p.no.id;
			q.no.ref = p.no.ref;
			q.no.chave = p.no.chave;

			var q = r.no.dir.nil;			
			p.no = p.no.dir.no;
			p.nil = q;
		} else
			this.removeSucessor(q, p.esq, preto, filho);
	}

	this.remove = function(chave) {
		if( !this.raiz.nil ) {
			var filho = { obj: null };
			var preto = { cor: false };

			this.removeAux(this.raiz, filho, chave, preto);
			if( preto.cor ) 				
				this.remanejarRemocao(this.raiz, filho);
			
		}
	}

	this.remanejarRemocao = function(raiz, x) {
		
		while( raiz && x.obj != raiz && (x.obj.nil == true || x.obj.no.cor == this.NEGRO) ) {
			
			if( x.obj.no.pai.no.esq == x.obj ) {
				var w = x.obj.no.pai.no.dir;

				if( !w.nil && w.no.cor == this.RUBRO ) {
					w.no.cor = this.NEGRO;
					x.obj.no.pai.no.cor = this.RUBRO;
					this.leftRotation(raiz, x.obj.no.pai);
					w = x.obj.no.pai.no.dir;
				}

				if( !w.nil && ((!w.no.esq.nil && w.no.esq.no.cor) && (!w.no.dir.nil && w.no.dir.no.cor)) ) {
					w.no.cor = this.RUBRO;
					x.obj = x.obj.no.pai.no.dir;					
				} else {
					if( !w.nil && !w.no.dir.nil && w.no.dir.no.cor == this.NEGRO ) {
						w.no.esq.no.cor == this.NEGRO;
						w.no.cor = this.RUBRO;
						this.rightRotation(raiz, w);
						w = w.no.pai.no.dir;
					}

					w.no.cor = x.obj.no.pai.no.cor;
					if( !w.no.dir.nil )
						w.no.dir.no.cor = this.NEGRO;

					x.obj.no.pai.no.cor = this.NEGRO;
					this.leftRotation(raiz, x.obj.no.pai);
					x.obj = raiz;
				}
			} else {
				var w = x.obj.no.pai.no.esq;

				if( !w.nil && w.no.cor == this.RUBRO ) {
					w.no.cor = this.NEGRO;
					x.obj.no.pai.no.cor = this.RUBRO;
					this.leftRotation(raiz, x.obj.no.pai);
					w = x.obj.no.pai.no.esq;
				}

				if( !w.nil && (!w.no.esq.nil && w.no.esq.no.cor) && (!w.no.dir.nil && w.no.dir.no.cor) ) {
					w.no.cor = this.RUBRO;
					x.obj = x.obj.no.pai.no.esq;
				} else {
					if( !w.no.esq.nil && w.no.esq.no.cor == this.NEGRO ) {
						w.no.dir.no.cor = this.NEGRO;
						w.no.cor = this.RUBRO;
						this.leftRotation(raiz, w);
						w = x.obj.no.pai.no.esq;
					}

					w.no.cor = x.obj.no.pai.no.cor;
					if( !w.no.esq.nil )
						w.no.esq.no.cor = this.NEGRO;

					x.obj.no.pai.no.cor = this.NEGRO;
					this.rightRotation(raiz, x.obj.no.pai);
					x.obj = raiz;
				}
			}
		}

		if( raiz && !raiz.nil ) {
			raiz.no.cor = this.NEGRO;
			raiz.nil = false;
		}
		if( !x.obj.nil ) 
			x.obj.no.cor = this.NEGRO;
	}

	this.show = function(raiz) {
		if( raiz.nil == false ) {
			this.show(raiz.no.esq);
			alert(raiz.no.chave+" "+raiz.no.cor);
			this.show(raiz.no.dir);
		}
	}
}; 


