jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function FilaCircular() {
    this.ini = null;
    this.fim = null;
    this.qtd = 0;
    FilaCircular.criaNo = function () {
        return {valor: null, dado: null, ant: null, prox: null};
    };

    this.insere = function (valor, dado) {
        var novo = FilaCircular.criaNo();
        novo.ant = null;
        novo.prox = null;
        novo.dado = dado;
        novo.valor = valor;

        if (!this.ini)
            this.ini = novo;
        else {
            novo.ant = this.fim;
            this.fim.prox = novo;
        }

        this.fim = novo;
        this.ini.ant = this.fim;
        this.fim.prox = this.ini;
        this.qtd++;
        Element.bind(this.fim,dado.id);
    };

    this.remove = function () {
        if (this.ini!==null) {
            if(this.ini.prox===this.ini) {
                this.ini = null;
                this.fim = null;
            } else {
                this.ini = this.ini.prox;
                this.ini.ant = this.fim;
                this.fim.prox = this.ini;
            }
            this.qtd--;
        }
    };

    this.size = function () {
        return this.qtd;
    };

}

(function () {
    var collection = new FilaCircular();

    var 
    deslocar = function(dados,offsetX,time){
       Plumb.moveTo(dados.id,parseInt(dados.d.style.left)+offsetX,parseInt(dados.d.style.top),time);  
    },
    animationAdd = function (elId) {
        UI.lock();

        var posFim = {left: 40, top: screen.height / 2.5};
        var qtd = collection.size();
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        highlighter.lines(0,2,50);
        if (qtd>1) {
            highlighter.line(5,500);
            highlighter.lineRed(3,500);
            highlighter.lines(7,8,1000);
            var elem = collection.fim.ant;
            posFim = {left: 40, top: parseInt(elem.dado.d.style.top)};
            for (var i = qtd - 2; i >= 0; i--) {
                deslocar(elem.dado,125,2000*speed);
                elem = elem.ant;
            }
        } else {
            highlighter.line(3,500);
            highlighter.line(4,1000);
        }
        highlighter.lines(10,12,1500);
        highlighter.clear(2000);
        Plumb.moveTo(elId, posFim.left, posFim.top, 2000 * speed);
        setTimeout(function(){
            connectDisc();
            UI.unlock();
            window.Eprogramada.nextQueue();
        },2000*speed);
    },
    animationSearch = function (elem) {
        UI.lock();
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.lines(0,3,50);
        var speed = getSpeed();
        var i = 0;
        var qtd = collection.size();
        var temp = collection.fim;
        var pos = {left: 40, top: screen.height / 2.5};
        while(i<qtd) {
            var looptime = 2000*i + 1000;
            pos = {left:parseInt(temp.dado.d.style.left),top:parseInt(temp.dado.d.style.top) - 65};
            Plumb.moveTo(elem.id, pos.left,pos.top,2000 * speed);
            highlighter.line(4,looptime);
            if (elem.valor == temp.valor){
                highlighter.line(6,looptime+500);
                highlighter.line(7,looptime+1000);
                highlighter.clear(looptime+2000);
                break;
            }
            i++;
            temp = temp.ant;
            highlighter.clear(looptime+450);
            highlighter.lineRed(6,looptime+450);
            highlighter.line(8,looptime+900);
            highlighter.line(9,looptime+1350);
            highlighter.clear(looptime+1650);
            if(i!=qtd){
                highlighter.lineRed(10,looptime+1650);
            } else {
                highlighter.line(10,looptime+1650);
                highlighter.line(11,looptime+2000);
                highlighter.line(13,looptime+2400);
                highlighter.clear(looptime+3000);
            }
        }
        if(i===qtd){
            var looptime = 2000*i + 1000;
            
        }
        setTimeout(function () {
            if (i != qtd) {
                var id = temp.dado.id;
                var obj = $("#" + id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            } else {
                Plumb.moveTo(elem.id, pos.left+125,pos.top,2000 * speed);
            }
            var objElem = $("#" + elem.id);
            objElem.fadeOut(2000*speed);

            setTimeout(function(){
                objElem.remove();
                UI.unlock();
            },2000*speed);
        }, (i + 1) * 2000 * speed);

    },
    animationRemove = function () {
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        UI.lock();
        if (collection.ini!==null) {
            highlighter.line(0,50);
            highlighter.lines(2,3,500);
            if(collection.ini.prox!==collection.ini){
                highlighter.line(4,1000);
                highlighter.lines(7,8,2000);
            } else{
                highlighter.lineRed(4,1000);
                highlighter.line(10,1000);
                highlighter.lines(12,15,2000);
            }
            highlighter.line(17,3000);
            highlighter.clear(4000);
            var obj = $("#" + collection.ini.dado.id);
            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);
            setTimeout(function () {
                if (collection.ini.prox!==null)
                    disconnectDisc();
                $("#" + collection.ini.dado.id).remove();
                collection.remove();
                connectDisc();
                UI.unlock();
                window.Eprogramada.nextQueue();
            }, 5500 * speed);
        } else {
            highlighter.lineRed(0,50);
            highlighter.clear(1000);
            window.Eprogramada.nextQueue();
        }
        setTimeout(function(){
            UI.unlock();
        },1000*speed);
    },
    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:[1, 0.7, 0, -1]});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor:[0, 0.3, 0, -1]});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor:[1, 0.3, 0, -1]});
    },
    prepare4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:[0, 0.7, 0, -1]});
    },
    prepareC1 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:[1, 0.7, 0, 1],type:"Flowchart"});
    },
    prepareC2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor:[0, 0.3, 0, -1],type:"Flowchart"});
    },
    prepareC3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor:[1, 0.3, 1, 0],type:"Flowchart"});
    },
    prepareC4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:[0, 0.7, -1, 0],type:"Flowchart"});
    },
    connectDisc = function () {
        var qtd = collection.size();
        if (qtd > 1) {
            var id1 = collection.fim.ant.dado.id;
            var id2 = collection.fim.dado.id;
            var idf = collection.ini.dado.id;
            Plumb.desconectarTodosCom({target: id1});
            Plumb.conectar(prepare(id2),prepare4(id1));
            Plumb.conectar(prepare3(id2),prepare2(id1));
            Plumb.conectar(prepareC1(idf),prepareC4(id2));
            Plumb.conectar(prepareC3(idf),prepareC2(id2));
        }
    },
    disconnectDisc = function () {
        Plumb.desconectarCompletamente(collection.ini.dado.id);
    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValue altColorTitle'>" + value + "</span>",
            left:"0px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.setProperty("primaryColorProperty",true);
            UI.InitInterface(this.search,this.elementToString);
        },
        elementToString: function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.valor};
                if (element.prox !== null) {
                    var nextId = (element.prox.dado.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.proximo = 'null';
                if (element.ant !== null) {
                    var nextId = (element.ant.dado.id * 1).toString(16).toUpperCase();
                    result.anterior = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.anterior = 'null';
                return result;
            }
            return false;
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor');
                if (value !== "") {
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    var info = createDisc(value);
                    collection.insere(value, info);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info.id, value);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {
            UI.subtitle("Removendo o primeiro da fila");
            animationRemove();
        },
        searchValue: function () {
            var value = UI.value('valor');
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }
    };
})();