/* global jsPlumb, Function */

jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function Fila() {
    this.ini = null;
    this.fim = null;

    Fila.criaNo = function () {
        return {
            valor: null,
            dados: null,
            prox: null,
            ant: null
        };
    };

    this.insere = function (valor, dado) {
        var novo = Fila.criaNo();

        novo.valor = valor;
        novo.dados = dado;

        if (!this.ini)
            this.fim = novo;
        else {
            novo.prox = this.ini;
            novo.ant = null;
            this.ini.ant = novo;
        }
        this.ini = novo;
        Element.bind(this.ini,dado.id);

    },
    this.remove = function () {
        if (this.fim) {
            this.fim = this.fim.ant;

            if (!this.fim)
                this.ini = null;
            else
                this.fim.prox = null;
        }
    };
};

(function () {
    var collection = new Fila();

    var 
    deslocarApartir = function (raiz, offsetX, tempo) {
        while (raiz !== null){
            deslocar(raiz.dados,offsetX,tempo);
            raiz = raiz.prox;
        }
    },
    deslocar = function (dados, offsetX, tempo) {
        Plumb.moveTo(dados.id,parseInt(dados.d.style.left)+offsetX,parseInt(dados.d.style.top),tempo);
    },
    setInitial = function(elId,key,text){
        $("#"+elId).find("span.initial").remove();
        if(key){
            $("#"+elId).append("<span class='initial'>"+text+"</span>");
        }
    },
    setFinal = function(elId,key){
        $("span.final").remove();
        if(key){
            $("#"+elId).append("<span class='final'>null</span>");
        }
    },
    animationAdd = function (elId) {
        UI.lock();

        var posFim = {left: 100, top: screen.height / 2.5};
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        highlighter.lines(0,2,10);
        
        if (collection.ini.prox!==null) {
            highlighter.lineRed(3,500);
            highlighter.line(5,1000);
            highlighter.lines(6,7,2500);
            highlighter.line(8,3000);
            highlighter.clear(4000);
            posFim = {left: 100, top: parseInt(collection.ini.prox.dados.d.style.top)};
            deslocarApartir(collection.ini.prox,125,1000*speed);
            setTimeout(function(){
                if(collection.ini.prox.prox===null) {
                    setInitial(collection.ini.dados.id,true,"Fila.inicio");
                    setInitial(collection.ini.prox.dados.id,true,"Fila.fim");
                } else {
                    setInitial(collection.ini.prox.dados.id,false);
                    setInitial(elId,true,"Fila.inicio");
                }
            },3000*speed);
            
        } else {
            setTimeout(function(){
                setInitial(elId,true,"<p>Fila.inicio</p><p>Fila.fim</p>");
                setFinal(elId,true);
            },3000*speed);
            highlighter.line(3,500);
            highlighter.line(4,1000);
            highlighter.line(8,2000);  
            highlighter.clear(2500);
        }
        
        setTimeout(function(){
            Plumb.moveTo(elId,posFim.left,posFim.top,2000 * speed);
            setTimeout(function(){
                connectDisc();
                UI.unlock();
                window.Eprogramada.nextQueue();
            },2000*speed);
        },1000*speed);
        
    },
    animationSearch = function (elem) {
        UI.lock();
        var i = 0;
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.lines(0,2,10);
        var temp = collection.ini;
        while (temp!==null) {
            
            var pos = {left:parseInt(temp.dados.d.style.left),top:parseInt(temp.dados.d.style.top) - 65};
            Plumb.moveTo(elem.id,pos.left,pos.top , 2000*speed);
            
            highlighter.line(3,2000*(i+1));
            
            if (elem.valor === temp.valor) {
                highlighter.line(5,2000*(i+1)+500);
                highlighter.line(6,2000*(i+1)+1000);
                highlighter.clear(2000*(i+2));
                break;
            } else {
                highlighter.lineRed(5,2000*(i+1)+500);
                highlighter.line(7,2000*(i+1)+1000);
                highlighter.line(8,2000*(i+1)+1500);
            }
            i++;
            temp = temp.prox;
        }
        
        if(temp===null && pos!==undefined){
            Plumb.moveTo(elem.id,pos.left+125,pos.top , 2000*speed);
        }
        
        setTimeout(function () {
            if (temp!==null) {
                var  obj = $("#"+temp.dados.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                highlighter.clear(6000);
                setTimeout(function(){
                    UI.unlock();
                },6000*speed);
            } else {
                highlighter.lineRed(3,500);
                highlighter.line(10,1000);
                highlighter.clear(2000);
                setTimeout(function(){
                    UI.unlock();
                },2000*speed);
            }
            $("#" + elem.id).fadeOut(1000 * speed);

        }, (i + 1.5) * 2000 * speed);

        setTimeout(function () {
            $("#" + elem.id).remove();
        }, (i + 2) * 2000 * speed);
    },
    animationRemove = function () {
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        if (collection.ini!==null) {
            var speed = getSpeed();
            UI.lock();
            var obj =  $("#"+collection.fim.dados.id);
            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);
            highlighter.line(0,10);
            highlighter.line(1,1000);
            if (collection.ini.prox!==null) {
                highlighter.line(5,2000);
                highlighter.lineRed(3,2000);
                highlighter.line(6,3000);
            } else {
                highlighter.line(3,2000);
                highlighter.line(4,3000);
            }
            highlighter.line(7,3500);
            highlighter.line(8,4000);
            highlighter.line(9,4500);
            highlighter.line(10,5000);
            highlighter.line(12,5500);
            setTimeout(function () {
                if (collection.ini.prox!==null) {
                    setFinal(collection.fim.ant.dados.id,true);
                    if(collection.ini.prox.prox!==null)
                        setInitial(collection.fim.ant.dados.id,true,"Fila.fim");
                    else
                        setInitial(collection.fim.ant.dados.id,true,"<p>Fila.inicio</p><p>Fila.fim</p>");
                    disconnectDisc();
                }
                setTimeout(function() {
                    obj.remove();
                    collection.remove();
                    UI.unlock();
                    window.Eprogramada.nextQueue();
                },1000 * speed);
            }, 5500 * speed);
        } else {
            highlighter.line(0,10);
            highlighter.lineRed(1,600);
            highlighter.line(12,1200);
            highlighter.clear(2000);
            window.Eprogramada.nextQueue();  
        }
    },
    prepare = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:false,anchor: [1, 0.7, 0, -1]});
    },
    prepare2 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor: [0, 0.3, 0, -1]});
    },
    prepare3 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor: [1, 0.3, 0, -1]});
    },
    prepare4 = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:false,anchor: [0, 0.7, 0, -1]});
    },
    connectDisc = function () {
        if (collection.ini.prox!==null) {
            var id1 = collection.ini.dados.id;
            var id2 = collection.ini.prox.dados.id;
            Plumb.conectar(prepare(id1),prepare4(id2));
            Plumb.conectar(prepare3(id1),prepare2(id2));
        }
    },
    disconnectDisc = function () {
        Plumb.desconectarCompletamente(collection.fim.dados.id);
    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValue altColorTitle'>" + value + "</span>",
            left:"100px",
            top:"75px",
            title: value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.setProperty("primaryColorProperty",true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.InitInterface(this.search,this.elementToString);
        },
        elementToString: function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var result = {'info':element.valor};
                if (element.prox !== null) {
                    var nextId = (element.prox.dados.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.proximo = 'null';
                if (element.ant !== null) {
                    var nextId = (element.ant.dados.id * 1).toString(16).toUpperCase();
                    result.anterior = '*' + (nextId.substring(nextId.length-5));
                } else
                    result.anterior = 'null';
                return result;
            }
            return false;
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor');
                if (value !== "") {
                    var info = createDisc(value);
                    collection.insere(value, info);
                    Plumb.tornarArrastavel(info.id);
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    animationAdd(info.id);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {
            UI.subtitle("Removendo o primeiro da fila");
            animationRemove();
        },
        searchValue: function () {
            var value = UI.value('valor');
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }

    };
})();
