jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function HashColisao() {
    this.MAX = 10;
    this.tabelaHash = new Array(this.MAX);

    HashColisao.criaNo = function () {
        return {ref: null, id: null, value: null};
    };

    this.inicia = function (MAX) {
        this.MAX = MAX || this.MAX;
        for (var i = 0; i < this.MAX; ++i)
            this.tabelaHash[i] = null;
    };

    this.hashFunction = function (chave) {
        var qtd = chave.length;
        var soma = 0;

        for (var i = 0; i < qtd; ++i)
            soma += (i + 1) * chave.charCodeAt(i);

        return soma % this.MAX;
    };

    this.insere = function (elem) {
        var ind = this.hashFunction(elem.valor);
        this.tabelaHash[ind] = HashColisao.criaNo();
        this.tabelaHash[ind].id = elem.id;
        this.tabelaHash[ind].ref = elem.d;
        this.tabelaHash[ind].value = elem.valor;
        Element.bind(this.tabelaHash[ind],elem.id,{index:ind});
    };

    this.remove = function (chave) {
        var ind = this.hashFunction(chave);

        if (this.tabelaHash[ind]!=null && this.tabelaHash[ind].value == chave)
            this.tabelaHash[ind] = null;

    };
}

(function () {
    var collection = new HashColisao();

    var 
    animationAdd = function (info) {
        UI.lock();
        var speed = getSpeed();
        var ind = collection.hashFunction(info.valor);
        var elementoNaPosicao = collection.tabelaHash[collection.hashFunction(info.valor)];
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        highlighter.line(0,10);
        highlighter.lineGreen(1,600);
        highlighter.line(2,1200);
        highlighter.clear(2000);
        Plumb.moveTo(info.id,295,250,2000*speed);
        var pos;
        if (elementoNaPosicao != null) {
            pos = {left: 535, top: 75 + (ind * 52)};
            Plumb.moveTo(info.id,pos.left,pos.top,2000*speed);

            setTimeout(function () {
                Plumb.moveTo(elementoNaPosicao.id,parseInt(elementoNaPosicao.ref.style.left) + 50,parseInt(elementoNaPosicao.ref.style.top),2000*speed);
            }, 4000 * speed);

            setTimeout(function () {
                $("#" + elementoNaPosicao.id).fadeOut(2000 * speed);
                Plumb.moveTo(info.id,pos.left + 70,pos.top,2000*speed);
            }, 6000 * speed);
        } else {
            Plumb.moveTo(info.id,605, 75 + (ind * 52),2000*speed);
        }

        setTimeout(function () {
            if (elementoNaPosicao != null)
                $("#" + elementoNaPosicao.id).remove();
            UI.unlock();
            window.Eprogramada.nextQueue();
        }, elementoNaPosicao != null ? 9000 * speed : 4000 * speed);
    },
    
    animationSearch = function (info) {
        UI.lock();
        var speed = getSpeed();
        var ind = collection.hashFunction(info.valor);
        var elementoNaPosicao = collection.tabelaHash[collection.hashFunction(info.valor)];
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        Plumb.moveTo(info.id,295,250,2000*speed);
        Plumb.moveTo(info.id,540, 75 + (ind * 52),2000*speed);
        
        highlighter.line(0,10);
        highlighter.lineGreen(1,10);
        
        if (elementoNaPosicao != null && elementoNaPosicao.value == info.valor) {

            setTimeout(function () {
                var obj = $("#" + elementoNaPosicao.id);
                obj.fadeOut(1000 * speed, "swing", changeColor(ind));
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            }, 4000 * speed);
            highlighter.line(2,500);
            highlighter.line(3,1000);
        } else {
            highlighter.line(4,1000);
        }
        
        highlighter.clear(2000);
        
        setTimeout(function () {
            $("#" + info.id).fadeOut(1000 * speed);
        }, 4000 * speed);

        setTimeout(function () {
            reset(ind);
            UI.unlock();
            $("#" + info.id).remove();
            window.Eprogramada.nextQueue();
        }, elementoNaPosicao != null ? 11000 * speed : 5000 * speed);

    },
    animationRemove = function (info) {
        UI.lock();
        var speed = getSpeed();
        var ind = collection.hashFunction(info.valor);
        var elementoNaPosicao = collection.tabelaHash[collection.hashFunction(info.valor)];
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);
        Plumb.moveTo(info.id,295,250,2000*speed);
        Plumb.moveTo(info.id,540,75 + (ind * 52),2000*speed);
        
        highlighter.line(0,10);
        highlighter.lineGreen(1,10);
        
        if (elementoNaPosicao != null && elementoNaPosicao.value == info.valor) {
            highlighter.line(2,500);
            highlighter.line(4,1000);
            highlighter.line(5,1500);
            highlighter.clear(2000);
            setTimeout(function () {
                var obj = $("#" + elementoNaPosicao.id);
                obj.fadeOut(1000 * speed, "swing", changeColor(ind));
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
            }, 4000 * speed);

        } else {
            highlighter.lineRed(2,1000);
            highlighter.clear(2000);
        }
        setTimeout(function () {
            $("#" + info.id).fadeOut(1000 * speed);
        }, 4000 * speed);

        setTimeout(function () {
            reset(ind);
            collection.remove(info.valor);
            $("#" + info.id).remove();
            UI.unlock();
            window.Eprogramada.nextQueue();
        }, elementoNaPosicao != null ? 11000 * speed : 5000 * speed);

    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicSmallDot altColor",
            innerHTML:"<span class='itemValue altColorTitle' style='top: 8px'>" + value + "</span>",
            left:"0px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    },
    reset = function(ind){
        Canvas.resetHash({indice:ind});
    };
    changeColor = function (ind) {
        Canvas.highlightHash({canvasId:"canv",indice:ind});
    },
    draw = function () {
        Canvas.drawHashTable({canvasId:"canv",total:collection.MAX,alternate:"html"});
    };

    window.Cadilag = {
        init: function () {
            UI.lock();
            $("#newStruct").click(this.newStruct);
            UI.setProperty("primaryColorProperty",true);
            UI.InitInterface(this.search,this.elementToString);
            Canvas.initInterface(this.elementIndexToString);
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicSmallDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        newStruct: function(){
            var size = UI.value("sizeArray","Tamanho do Vetor é invalido");
            if(size!=="") {
                UI.setParameters({TAMANHO_DA_TABELA:collection.MAX});
                UI.InitFunctions(Cadilag.addDisc,Cadilag.removeValue,Cadilag.searchValue);
                $("#newStruct").unbind('click');
                collection.inicia(size);
                draw();
                UI.unlock();
                $("#subtopbar").animate({"top":"0px"},500,function(){
                    $(this).remove();
                });
            }
        },
        elementIndexToString: function (index) {
            var arraypos = collection.tabelaHash[index];
            if (arraypos === null) {
                return {'_replaceAll':'null','_index':index,'_title':'TabelaHash'};
            } else if(arraypos !== undefined) {
                return {'info':arraypos.value,'_index':index,'_title':'TabelaHash'};
            }
            return false;
        },
        elementToString:function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var vars  = Element.getVars(id);
                var result = {'info':element.value,'_gravity':'e','_index':vars.index,'_title':'TabelaHash'};
                return result;
            }
            return false; 
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor');
                if (value !== "") {
                    var info = createDisc(value);
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    animationAdd(info);
                    collection.insere(info);
                }
            } else {
                History.rollbackAppendInput();
            }

        },
        removeValue: function () {
            var value = UI.value('valor');
            if (value !== "") {
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationRemove(info);
            }
        },
        searchValue: function () {
            var value = UI.value('valor');
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }
    };
})();