jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function No() {
    var value;
    var proximoElemento;
    var ref;
    var id;
}

function ListaEncadeadaOrdenadaEstatica() {
    this.MAX = 13;
    this.NAO_APONTA = -1;
    this.indiceDisponivel = 0;
    this.indicePrimeiroElemento = this.NAO_APONTA;
    this.dados = new Array(this.MAX);

    this.inicia = function (MAX) {
        this.MAX = parseInt(MAX) || this.MAX;
        this.indicePrimeiroElemento = -1;
        this.indiceDisponivel = 0;
        for (var i = 0; i < this.MAX - 1; ++i) {
            this.dados[i] = new No();
            this.dados[i].proximoElemento = i + 1;
        }
        this.dados[i] = new No();
        this.dados[i].proximoElemento = this.NAO_APONTA;
    };

    this.isEmpty = function () {
        return this.indicePrimeiroElemento == this.NAO_APONTA;
    };

    this.size = function () {
        var qtd = 0, i = this.indicePrimeiroElemento;

        while (i != this.NAO_APONTA) {
            qtd++;
            i = this.dados[i].proximoElemento;
        }
        return qtd;
    };

    this.at = function (i) {
        var j = this.indicePrimeiroElemento;

        while (i && i != this.NAO_APONTA) {
            i--;
            j = this.dados[j].proximoElemento;
        }

        return this.dados[j];
    };

    this.remove = function (elem) {
        var anterior = -1, i = this.indicePrimeiroElemento;
        var flag = false;

        if (!this.isEmpty())
        {
            if (this.size() > 1)
            {
                while (i != this.NAO_APONTA && !flag)
                {
                    if (elem == this.dados[i].value)
                    {
                        flag = true;
                        var novoIndiceDisponivel;

                        if (anterior == -1)
                        {
                            novoIndiceDisponivel = i;
                            this.indicePrimeiroElemento = this.dados[i].proximoElemento;
                        } else
                        {
                            novoIndiceDisponivel = this.dados[anterior].proximoElemento;
                            this.dados[anterior].proximoElemento = this.dados[i].proximoElemento;
                        }

                        this.dados[i].proximoElemento = this.indiceDisponivel;
                        this.indiceDisponivel = novoIndiceDisponivel;
                    }
                    anterior = i;
                    i = this.dados[i].proximoElemento;
                }
            } else if (this.size() == 1)
            {
                if (elem == this.dados[i].value)
                {
                    this.indicePrimeiroElemento = this.NAO_APONTA;
                    this.dados[i].proximoElemento = this.indiceDisponivel;
                    this.indiceDisponivel = i;
                }
            }
        }
    };

    this.insere = function (elem) {
        if (this.size() != this.MAX){
            
            this.dados[this.indiceDisponivel].value = elem.valor;
            this.dados[this.indiceDisponivel].id = elem.id;
            this.dados[this.indiceDisponivel].ref = elem.d;
            Element.bind(this.dados[this.indiceDisponivel],elem.id,{index:this.indiceDisponivel});
            var auxDisp = this.dados[this.indiceDisponivel].proximoElemento;
            this.dados[this.indiceDisponivel].proximoElemento = this.NAO_APONTA;

            if (!this.isEmpty()) {

                var anterior = -1, i = this.indicePrimeiroElemento;

                while (i != this.NAO_APONTA && parseFloat(this.dados[i].value) < parseFloat(elem.valor)) {
                    anterior = i;
                    i = this.dados[i].proximoElemento;
                }

                if (anterior == -1) {
                    this.dados[this.indiceDisponivel].proximoElemento = this.indicePrimeiroElemento;
                    this.indicePrimeiroElemento = this.indiceDisponivel;
                } else {
                    if (i != this.NAO_APONTA)
                        this.dados[this.indiceDisponivel].proximoElemento = this.dados[anterior].proximoElemento;
                    this.dados[anterior].proximoElemento = this.indiceDisponivel;
                }
            } else
                this.indicePrimeiroElemento = this.indiceDisponivel;
            this.indiceDisponivel = auxDisp;
        }
    };

    this.search = function (value) {
        var i = this.indicePrimeiroElemento;
        while (i != this.NAO_APONTA && this.dados[i].value != value)
            i = this.dados[i].proximoElemento;
        return i;
    };
}

(function () {
    var collection = new ListaEncadeadaOrdenadaEstatica();

    var
    pointerprox=null,pointerini=null,
    createPointer = function(text){
        return Element.createElement(
            {className:"staticpointer",
            innerHTML:text,
            left:"3px",
            top:"350px",
            idParent:"main"});
    },
    updatePointerProx = function(time){
        if(collection.indicePrimeiroElemento!==collection.NAO_APONTA) {
            if(pointerprox===null)
                pointerprox = createPointer("<p>Primeiro<br>indice</p>");
            $("#"+pointerprox.id).animate({left:72 * collection.indicePrimeiroElemento+3,top:parseInt(pointerprox.d.style.top)},time);
        } else {
            if(pointerprox!==null){
                $("#"+pointerprox.id).fadeOut(time);
                setTimeout(function(){
                    $("#"+pointerprox.id).remove();
                    pointerprox=null;
                },time);
            }
        }
    },
    updatePointerIni = function(time){
        if(collection.indiceDisponivel!==collection.NAO_APONTA) {
            if(pointerini===null)
                pointerini = createPointer("<p>indice</p>");
            $("#"+pointerini.id).animate({left:72 * collection.indiceDisponivel+3,top:parseInt(pointerini.d.style.top)},time);
        } else {
            if(pointerini!==null){
                $("#"+pointerini.id).fadeOut(time);
                setTimeout(function(){
                    $("#"+pointerini.id).remove();
                    pointerini=null;
                },time);
            }
        }
    },
    animationAdd = function (elId) {
        UI.lock();
        var speed = getSpeed();
        var desl = 72;
        if(collection.MAX!==collection.size()) {
            Plumb.moveTo(elId,desl * collection.indiceDisponivel + 2,279,2000 * speed);
            setTimeout(function(){
                updatePointerProx(1500*speed);
                updatePointerIni(1500*speed);
                setTimeout(function () {
                    UI.unlock();
                    update();
                    window.Eprogramada.nextQueue();
                }, 1500 * speed);
            },1000*speed);
        } else {
            Plumb.moveTo(elId,desl * collection.MAX + 2,279,2000 * speed);
            setTimeout(function(){
                $("#"+elId).fadeOut(2000*speed);
                setTimeout(function(){
                    $("#"+elId).remove();
                },2000*speed);
                UI.unlock();
                update();
                window.Eprogramada.nextQueue();
            },2000*speed);
        }

    },
    animationSearch = function (elId, value) {
        UI.lock();
        var speed = getSpeed();
        var i = collection.indicePrimeiroElemento;
        var qtd = 0;

        while (i != collection.NAO_APONTA) {
            Plumb.moveTo(elId,parseInt(collection.dados[i].ref.style.left),parseInt(collection.dados[i].ref.style.top) - 83,2000 * speed);
            if (collection.dados[i].value == value)
                break;
            i = collection.dados[i].proximoElemento;
            qtd++;
        }
        
        setTimeout(function () {
            if (i != collection.NAO_APONTA) {
                var obj = $("#" + collection.dados[i].id);
                obj.fadeOut(1000 * speed, "swing", changeColor(i));
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
            }
            $("#" + elId).fadeOut(2000 * speed);
        }, (qtd + 1) * 2000 * speed);

        setTimeout(function () {
            UI.unlock();
            $("#" + elId).remove();
            resetColor(i);
        }, (qtd + 1) * 2000 * speed + (i != collection.NAO_APONTA ? 8000 * speed : 2000 * speed));

    },
    animationRemove = function (info) {
        UI.lock();
        var speed = getSpeed();
        var i = collection.indicePrimeiroElemento;
        var qtd = 0;

        while (i != collection.NAO_APONTA) {
            Plumb.moveTo(info.id,parseInt(collection.dados[i].ref.style.left),parseInt(collection.dados[i].ref.style.top) - 83,2000 * speed);
            if (collection.dados[i].value == info.valor)
                break;
            i = collection.dados[i].proximoElemento;
            qtd++;

        }

        setTimeout(function () {

            if (i != collection.NAO_APONTA) {
                UI.lock();
                var obj = $("#" + collection.dados[collection.search(parseInt(info.valor))].id);
                var pos = collection.search(parseInt(info.valor));
                obj.fadeOut(1000 * speed, "swing", changeColor(pos));
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);

                setTimeout(function () {
                    resetColor(pos);
                    $("#" + collection.dados[collection.search(parseInt(info.valor))].id).remove();
                    collection.remove(parseInt(info.valor));
                    updatePointerProx(2000*speed);
                    updatePointerIni(2000*speed);
                    setTimeout(function(){
                        UI.unlock();
                        window.Eprogramada.nextQueue();
                    },2000*speed);
                }, 5250 * speed);
            } else {
                setTimeout(function(){
                    UI.unlock();
                    window.Eprogramada.nextQueue();
                },2000*speed);
            }
            $("#" + info.id).fadeOut(2000 * speed);
        }, (qtd + 1) * 2000 * speed);
    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValue altColorTitle'>" + value + "</span>",
            left:"0px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    },
    changeColor = function (ind) {
        Canvas.highlight({canvasId:'canv',indice:ind});
    },
    resetColor = function(ind){
        Canvas.reset({indice:ind});
    },
    update = function () {
        var labels = [];
        for(var i=0;i<collection.MAX;i++)
            labels[i] = collection.dados[i].proximoElemento;
        Canvas.updateLabels({labels:labels,total:collection.MAX});
    };
    draw = function () {
        var labels = [];
        for(var i=0;i<collection.MAX;i++)
            labels[i] = collection.dados[i].proximoElemento;
        Canvas.drawArray({canvasId:'canv',total:collection.MAX,labels:labels,labelTitle:"Indices do próximo elemento",alternate:"html"});
    };

    window.Cadilag = {
        init: function () {
            UI.lock();
            UI.setProperty("primaryColorProperty",true);
            $("#newStruct").click(this.newStruct);
            UI.InitInterface(this.search,this.elementToString);
            Canvas.initInterface(Cadilag.elementIndexToString);
        },
        newStruct: function(){
            var size = UI.value("sizeArray","Tamanho do Vetor é invalido");
            if(size!=="") {
                UI.setParameters({MAXIMO:collection.MAX});
                UI.InitFunctions(Cadilag.addDisc,Cadilag.removeValue,Cadilag.searchValue);
                $("#newStruct").unbind('click');
                collection.inicia(size);
                draw();
                UI.unlock();
                $("#subtopbar").animate({"top":"0px"},500,function(){
                    $(this).remove();
                });
            }
        },
        elementIndexToString: function (index) {
            var arraypos = collection.dados[index];
            if (arraypos.value === null || arraypos.value === undefined) {
                return {'info':'null','proximo_elemento':arraypos.proximoElemento,'_index':index,'_title':'Lista'};
            } else {
                return {'info':arraypos.value,'proximo_elemento':arraypos.proximoElemento,'_index':index,'_title':'lista'};
            }
            return false;
        },
        elementToString:function(id){
            var element = Element.get(id);
            if(element!==undefined){
                var vars  = Element.getVars(id);
                var result = {'info':element.value,'proximo_elemento':element.proximoElemento,'_index':vars.index,'_title':'lista','_gravity':(vars.index===0?'sw':(vars.index===collection.MAX-1?'se':'s'))};
                return result;
            }
            return false; 
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        addDisc: function () {
            if(UI.checkInterface()){
                var value = UI.value('valor',"O valor deve ser um número");
                if (value !== "") {
                    var info = createDisc(value);
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    animationAdd(info.id);
                    collection.insere(info);
                }
            } else {
                History.rollbackAppendInput();
            }

        },
        removeValue: function () {
            var value = UI.value('valor',"O valor deve ser um número");
           
            if (value !== "") {
                UI.subtitle("Removendo o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationRemove(info);
            }
        },
        searchValue: function () {
            var value = UI.value('valor',"O valor deve ser um número");
            
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info.id, value);
            }
        }
    };

})();