jsPlumb.bind("ready", function () {
    Cadilag.init();
});

function Pilha() {
    // cria um nó
    Pilha.criaNo = function () {
        return {valor: null, dados: null, prox: null
        };
    };

    this.ini = null;

    this.insere = function (valor, dado)
    {
        var novo = Pilha.criaNo();

        novo.prox = this.ini;
        Element.bind(novo,dado.id);
        this.ini = novo;
        this.ini.dados = dado;

        this.ini.valor = valor;
    };

    this.remove = function () {
        this.ini = this.ini.prox;
    };

}

(function () {
    var collection = new Pilha();

    var
    deslocarApartir = function (raiz, offsetX, tempo) {
        while (raiz !== null){
            deslocar(raiz.dados,offsetX,tempo);
            raiz = raiz.prox;
        }
    },
    deslocar = function (dados, offsetX, tempo) {
        Plumb.moveTo(dados.id,parseInt(dados.d.style.left)+offsetX,parseInt(dados.d.style.top),tempo);
    },
    setInitial = function(elId,key){
        $("span.initial").remove();
        if(key){
            $("#"+elId).append("<span class='initial'>Pilha</span>");
        }
    },
    setFinal = function(elId,key){
        $("span.final").remove();
        if(key){
            $("#"+elId).append("<span class='final'>null</span>");
        }
    },
    animationAdd = function (elId) {
        UI.lock();
        var speed = getSpeed();
        var raiz = collection.ini.prox;
        var highlighter = new HighlighterAlgoritmo(VK.INSERCAO);
        highlighter.lines(0, 2, 10);
        highlighter.lines(3, 4, 1000);
        highlighter.clear(2000);
        deslocarApartir(raiz,125,1000*speed);
        setTimeout(function () {
            Plumb.moveTo(elId,75,screen.height / 2.5,1500*speed);
            highlighter.clear(2000);
            setTimeout(function(){
                if(collection.ini.prox===null) {
                    setFinal(elId,true);
                }
                setInitial(collection.ini.dados.id,true);
                connectDisc();
                Plumb.repintarElemento(elId);
                UI.unlock();
                window.Eprogramada.nextQueue();
            },2000*speed);

        }, 1000 * speed);

    },
    animationSearch = function (elem) {
        UI.lock();
        var i = 0;
        var speed = getSpeed();
        var highlighter = new HighlighterAlgoritmo(VK.BUSCA);
        highlighter.lines(1, 2, 10);
        var temp = collection.ini;
        var objelem = $("#"+elem.id);
        while(temp!==null) {
            var pos = {left: parseInt(temp.dados.d.style.left), top: parseInt(temp.dados.d.style.top) - 65};
            Plumb.moveTo(elem.id,pos.left,pos.top,2000 * speed);

            if (elem.valor === temp.valor) {
                highlighter.line(3, 2000 * (i + 1) - 1000);
                highlighter.line(4, 2000 * (i + 1));
                highlighter.line(5, 2000 * (i + 1) + 1000);
                highlighter.clear( 2000 * (i + 2));
                break;
            } else {
                highlighter.line(3, 2000 * (i + 1) - 1000);
                highlighter.lineRed(4, 2000 * (i + 1));
            }
            i++;
            temp = temp.prox;
        }

        if (temp===null) {
            Plumb.moveTo(elem.id,pos.left+125,pos.top,2000*speed);
        }
        if(i===0) {
        } else {
        }
        setTimeout(function () {
            if (temp!==null) {
                var obj = $("#" + temp.dados.id);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                obj.fadeOut(1000 * speed);
                obj.fadeIn(1000 * speed);
                setTimeout(function () {
                    UI.unlock();
                    window.Eprogramada.nextQueue();
                }, 7000 * speed);
            } else {
                highlighter.clear(0);
                highlighter.lineRed(3, 10);
                highlighter.line(6, 1000);
                highlighter.clear(2000);
                setTimeout(function () {
                    UI.unlock();
                    window.Eprogramada.nextQueue();
                }, 1000 * speed);
            }
            objelem.fadeOut(1000 * speed);
        }, (i + 1.5) * 2000 * speed);

        setTimeout(function () {
            objelem.remove();
        }, (i + 2) * 2000 * speed);

    },
    animationRemove = function () {
        var highlighter = new HighlighterAlgoritmo(VK.REMOCAO);

        if(collection.ini!==null) {
            UI.lock();

            highlighter.line(2, 10);
            highlighter.line(3, 500);
            highlighter.line(4, 1000);
            highlighter.line(5, 1500);
            highlighter.clear(2000);

            var speed = getSpeed();
            var obj = $("#"+collection.ini.dados.id);

            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);
            obj.fadeIn(1000 * speed);
            obj.fadeOut(1000 * speed);

            setTimeout(function () {
                if(collection.ini.prox!==null) {
                    setInitial(collection.ini.prox.dados.id,true);
                }
                disconnectDisc();
                deslocarApartir(collection.ini,-125,2000*speed);
                collection.remove();
                UI.unlock();
                window.Eprogramada.nextQueue();
            }, 5000 * speed);
        } else {
            highlighter.lineRed(0, 10);
            highlighter.clear(2000);
            setTimeout(function(){
                UI.unlock();
                window.Eprogramada.nextQueue();
            },2000);
        }
    },

    prepareAnt = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:false,isTarget:true,isPrimary:true,anchor:"Right"});
    },
    prepareProx = function (elId) {
        return Plumb.adicionarPontoDeConexao(elId,{isSource:true,isTarget:false,isPrimary:true,anchor:"Left"});
    },
    connectDisc = function () {
        if (collection.ini.prox!==null) {
            Plumb.conectar(prepareAnt(collection.ini.dados.id),prepareProx(collection.ini.prox.dados.id));
        }
    },
    disconnectDisc = function () {
        Plumb.desconectarCompletamente(collection.ini.dados.id);
    },
    createDisc = function (value) {
        var elem = Element.createElement(
            {className:"dinamicDot altColor",
            innerHTML:"<span class='itemValue altColorTitle'>" + value + "</span>",
            left:"100px",
            top:"75px",
            title:value,
            idParent:"main"});
        elem.valor = value;
        return elem;
    };

    window.Cadilag = {
        init: function () {
            Plumb.init(true);
            UI.setProperty("primaryColorProperty",true);
            UI.InitFunctions(this.addDisc,this.removeValue,this.searchValue);
            UI.InitInterface(this.search,this.elementToString);
        },
        search: function(){
            var value = UI.value("valor");
            if(value!==""){
                return $(".dinamicDot[title='"+value+"']").length!==0;
            }
            return false;
        },
        elementToString: function(id){
            var element = Element.get(id);
            if (element !== undefined) {
                var result = {'info': element.valor};
                if (element.prox !== null) {
                    var nextId = (element.prox.dados.id * 1).toString(16).toUpperCase();
                    result.proximo = '*' + (nextId.substring(nextId.length - 5));
                } else
                    result.proximo = 'null';
                return result;
            }
            return false;
        },
        addDisc: function () {
            if (UI.checkInterface()) {
                var value = UI.value('valor');
                if (value !== "") {
                    UI.subtitle("Inserindo o valor <b>"+value+"</b>");
                    var info = createDisc(value);
                    collection.insere(value, info);
                    Plumb.tornarArrastavel(info.id);
                    animationAdd(info.id);
                }
            } else {
                History.rollbackAppendInput();
            }
        },
        removeValue: function () {
            UI.subtitle("Removendo o último elemento da pilha");
            animationRemove();
        },
        searchValue: function () {

            var value = UI.value('valor');
            if (value !== "") {
                UI.subtitle("Buscando o valor <b>"+value+"</b>");
                var info = createDisc(value);
                animationSearch(info);
            }
        }

    };
})();