/* global Opentip */

jsPlumb.bind("ready", function () {
    $("#eprun").addClass("lockable");
    $("#EpRunDiv").addClass("lockable");
    $("#valor").addClass("inputFunction");
    $(".input-required").addClass("lockable");
    $(".random-btn").click(function () {
        randomInput(this);
    });
    $("#float").hide();
    $("#UserDiv").click(function () {
        $("#huboptions").slideToggle({duration: 300, easing: "easeOutCirc"});
    });
    $('#time').on('input',function () {
        window.TimeApp.updateTime();
    });
    $(".cool-checkbox").click(function () {
        var obj = $(this);
        obj.tipsy(true).hide();
        obj.toggleClass("selected");
        if (obj.hasClass('selected')) {
            obj.attr('title', 'OFF | <tipsym>ON</tipsym>');
        } else {
            obj.attr('title', '<tipsym>OFF</tipsym> | ON');
        }
        var id = obj.attr('id');
        localStorage.setItem(id + 'Cadilag', obj.hasClass('selected'));
        obj.tipsy(true).show();
    });
    $("#mobile-interface").click(function () {
        if ($(this).hasClass('selected')) {
            $(".mobile").each(function () {
                if (!$(this).hasClass('toM')) {
                    $(this).addClass('toM');
                }
            });
        } else {
            $('.toM').removeClass('toM');
        }
    });
    $("#sidebar > ul > li").each(function () {
        var thisObj = $(this);
        var title = thisObj.attr('title');
        thisObj.tipsy({title: function () {
                return "<tipsym>" + title + "</tipsym>"
            }, html: true, gravity: 'e'});
    });
    $(".p_integer").attr("pattern", "[0-9]*");
    $(".navbar").tipsy({fallback: "<tipsym>Mostrar Estruturas</tipsym>", html: true, gravity: 'n'});
    $("#feedback").tipsy({fallback: "<tipsym>Feedback</tipsym>", html: true, gravity: 'sw', clsStyle: 'medium'});
    $(".cool-checkbox").each(function () {
        var obj = $(this);
        var id = obj.attr('id');
        var result = localStorage.getItem(id + 'Cadilag');
        if (result !== null) {
            if (result === 'true') {
                obj.addClass('selected');
            } else {
                obj.removeClass('selected');
            }
        }
        if (obj.hasClass('selected')) {
            obj.attr('title', 'OFF | <tipsym>ON</tipsym>');
        } else {
            obj.attr('title', '<tipsym>OFF</tipsym> | ON');
        }
        obj.tipsy({title: 'title', html: true, gravity: 'n'});
    });

    $(".appbuttons button").each(function () {
        $(this).tipsy({title: 'title', html: true, gravity: 'n', delayIn: 200});
    });
    $(window).resize(function () {
        if (!$("#mobile-interface").hasClass("selected")) {
            if (parseInt($(this).width()) < 600) {
                $(".mobile").each(function () {
                    if (!$(this).hasClass('toM')) {
                        $(this).addClass('toM');
                    }
                });
            } else {
                $('.toM').removeClass('toM');
            }
        }
    });
    $(".resetColor").click(function () {
        var target = $(this).attr('for');

        document.getElementById(target).jscolor.fromString($("#" + target).attr('original-value'));
        if (target === "colorChooserAlt") {
            UI.updateColorPrimary();
            UI.changeColorComponentPrimary();
        } else if (target === "colorChooserAlt1") {
            UI.updateColorSecondary();
            UI.changeColorComponentSecondary();
        }
    });

    UI.loadCache();
});

function randomInput(d) {
    var itemref = $(d).attr('itemref');
    var obj = $("#" + itemref);
    if (obj.hasClass('p_integer')) {
        if (obj.hasClass('p_interval')) {
            var valorinicial = obj.val();
            while (obj.val() === valorinicial) {
                var max = parseInt(obj.attr('max'));
                var min = parseInt(obj.attr('min'));
                obj.val(parseInt(min + Math.random() * (max - min)));
            }
        } else {
            var maxlength = obj.attr('maxlength');
            var max = parseInt(Math.random() * maxlength) + 1;
            var random = parseInt(Math.random() * Math.pow(10, parseInt(max)));
            if (random < Math.pow(10, parseInt(maxlength) - 1)) {
                var randombool = parseInt(Math.random() * 2);
                if (randombool === 0) {
                    random *= -1;
                }
            }
            obj.val(random);
        }
    } else if (obj.hasClass('p_number')) {
        var maxlength = obj.attr('maxlength');
        var max = parseInt(Math.random() * maxlength) + 1;
        var random = ('' + (Math.random() * Math.pow(10, parseInt(maxlength)))).substring(0, max);

        if (random.length < parseInt(maxlength)) {
            var randombool = parseInt(Math.random() * 2);
            if (randombool === 0) {
                random *= -1;
            }
        }
        random = random + '';
        if (random.charAt(random.length - 1) === '.') {
            random = random.replace('.', '');
        }
        obj.val(random);
    }
}

(function () {
    window.UI = {
        primaryColorProperty: false,
        secondaryColorProperty: false,
        validatorFunction: false,
        elementToString: false,
        InitFunctions: function (addf, remf, searchf) {
            $("#add").click(function () {
                addf();
            });
            $("#remove").click(function () {
                remf();
            });
            $("#search").click(function () {
                searchf();
            });
        },
        InitInterface: function (validatorf, toStringElement) {
            this.validatorFunction = validatorf;
            if (this.elementToString !== undefined)
                this.elementToString = toStringElement;
        },
        checkInterface: function () {
            if ($("#repetirEntrada").hasClass('selected')) {
                if (this.validatorFunction()) {
                    this.lancarMensagem("Esta entrada já existe");
                    return false;
                }
            }
            return true;
        },
        lancarMensagem: function (mensagem) {
            var qtd = $(".message").length;
            var obj = $('<span/>', {
                class: 'message',
                text: mensagem,
                appendTo: $("body")
            }).css("bottom", ((qtd + 0.5) * 45) + "px");
            setTimeout(function () {
                obj.remove();
            }, 2000);
        },
        setProperty: function (type, value) {
            this[type] = value;
            if (this.primaryColorProperty) {
                $("#primaryColor").show();
                $("#colorChooserAlt").tipsy({title: 'title', html: true, gravity: 'n'});
            } else {
                $("#primaryColor").hide();
            }
            if (this.secondaryColorProperty) {
                $("#secondaryColor").show();
                $("#colorChooserAlt1").tipsy({title: 'title', html: true, gravity: 'n'});
            } else {
                $("#secondaryColor").hide();
            }
        },
        subtitle: function (text) {
            if (text !== undefined) {
                document.getElementById('subtitle').innerHTML = text;
            } else {
                return document.getElementById('subtitle').innerHTML;
            }
        },
        removeSubtitle: function () {
            document.getElementById('subtitle').innerHTML = "";
        },
        AddInput: function (id) {
            $("#" + id).addClass("inputFunction");
            var totalInputs = $("input.inputFunction").length;
            $("#title-history").html("");
            var title = document.getElementById("title-history");
            $("input.inputFunction").each(function () {
                var d = document.createElement("li");
                d.style.width = "calc(" + (100 / totalInputs) + "% - 1px)";
                d.innerHTML = $(this).attr("name");
                title.appendChild(d);
            });
        },
        lock: function () {
            $(".lockable").attr("disabled", "disabled");
        },
        loadCache: function () {
            setTimeout(function () {
                var color = localStorage.getItem("primaryColorCadilag");
                var color1 = localStorage.getItem("secondaryColorCadilag");
                if (color !== null) {
                    document.getElementById('colorChooserAlt').jscolor.fromString(color);
                    UI.changeColorComponentPrimary();
                } else {
                    document.getElementById('colorChooserAlt').jscolor.fromString($('#colorChooserAlt').attr("original-value"));
                }
                if (color1 !== null) {
                    document.getElementById('colorChooserAlt1').jscolor.fromString(color1);
                    UI.changeColorComponentSecondary();
                } else {
                    document.getElementById('colorChooserAlt1').jscolor.fromString($('#colorChooserAlt1').attr("original-value"));
                }
            }, 1000);
        },
        updateColorPrimary: function () {
            var d = document.getElementById('colorChooserAlt');
            localStorage.setItem("primaryColorCadilag", d.value);
        },
        updateColorSecondary: function () {
            var d = document.getElementById('colorChooserAlt1');
            localStorage.setItem("secondaryColorCadilag", d.value);
        },
        changeColorComponentPrimary: function () {
            var d = document.getElementById('colorChooserAlt');
            var componentes = $(".altColor");
            componentes.css("background-color", "#" + d.value);
            componentes = $(".altColorTitle");
            componentes.css("color", d.style.color);
        },
        changeColorComponentSecondary: function () {
            var d = document.getElementById('colorChooserAlt1');
            var componentes = $(".altColor1");
            componentes.css("background-color", d.value);
            componentes = $(".altColorTitle1");
            componentes.css("color", d.style.color);
        },
        unlock: function () {
            $(".lockable").removeAttr("disabled");
            this.removeSubtitle();
        },
        value: function (id, mensagemError) {
            if (mensagemError !== undefined) {
                if (!document.getElementById(id).checkValidity()) {
                    this.lancarMensagem("Entrada Inválida: " + mensagemError);
                    return "";
                }
            }
            var value = $("#" + id).val();
            value = $.trim(value);
            return value;
        },
        setProgress: function (percent, time) {
            if ($("#enableTemporizador").hasClass('selected')) {
                if (percent === 0) {
                    $("#float").fadeOut(time);
                    setTimeout(function () {
                        $("#float").css("width", "0%");
                    }, time);
                } else {
                    $("#float").show();
                    $("#float").animate({"width": (percent * 100) + "%", "opacity": "1"}, time, "linear");
                }
            }
        }, setParameters: function (params) {
            var saida = "";
            for (var k in params) {
                saida += "<p>" + k + " <g>:=</g> " + params[k] + ";</p>";
            }
            document.getElementById("parameters").innerHTML = saida;

        }

    };
    window.Tooltip = {
        records: [],
        createStyle: function (name, parameter) {
            Opentip.styles[name] = parameter;
        },
        register: function (id, d, style) {
            this.records[id] = new Opentip(d, "", {style: style});
        },
        deactivate: function (id) {
            this.records[id].deactivate();
        },
        show: function (id, text, color, time) {
            var record = this.records[id];
            record.setContent(text);
            record.options.background = color;
            record.show();
            setTimeout(function () {
                record.hide();
            }, time);
        }
    };
    window.Element = {
        elements: [],
        bind: function (element, id, vars) {
            this.elements[id] = {element: element, vars: vars};
        },
        get: function (id) {
            if (this.elements[id] !== undefined)
                return this.elements[id].element;
        },
        getVars: function (id) {
            if (this.elements[id] !== undefined)
                return this.elements[id].vars;
        },
        mouseEnterEvent: function (id) {
            if ($("#enableDescritor").hasClass('selected')) {
                var array = UI.elementToString(id);
                if (array) {
                    var thisId = (id * 1).toString(16).toUpperCase();
                    var saida = "<p class='tipsy-head'>";
                    if (array._title === undefined) {
                        saida += "*" + thisId.substring(thisId.length - 5);
                    } else {
                        saida += array._title;
                    }
                    if (array._index !== undefined) {
                        saida += "[" + array._index + "]";
                    }
                    saida += "</p>";
                    if (array._replaceAll === undefined) {
                        saida += "<table class='tipsy-table'><tr><th>Campo</th><th>Valor</th></tr>";

                        for (var key in array) {
                            if (!key.startsWith("_"))
                                saida += "<tr><td>" + key + "</td><td>" + array[key] + "</td></tr>";
                            ;
                        }
                        saida += "</table>";
                    } else {
                        saida += array._replaceAll;
                    }

                    var obj = $("#" + id);
                    if (array._gravity !== undefined) {
                        obj.tipsy(true).options.gravity = array._gravity;
                    }
                    obj.attr('tipsy-title', saida);
                    obj.tipsy(true).show();
                }
            }
        },
        mouseExitEvent: function (id) {
            var obj = $("#" + id);
            obj.tipsy(true).hide();
        },
        createElement: function (parameter) {
            var id = '' + ((new Date().getTime()));
            while ($("#" + id).length !== 0) {
                id--;
            }
            var filter = function (text) {
                return (text !== undefined ? text : "");
            };

            var obj = $('<div/>', {
                id: id,
                class: filter(parameter.className),
                html: filter(parameter.innerHTML),
                title: filter(parameter.title),
                appendTo: $("#" + parameter.idParent)
            }).css("left", parameter.left)
                    .css("top", parameter.top)
                    .attr("title", parameter.title);

            if (UI.elementToString) {
                obj.mouseover(function () {
                    Element.mouseEnterEvent(id);
                });
                obj.mouseout(function () {
                    Element.mouseExitEvent(id);
                });
                obj.attr('tipsy-title', '');
                obj.tipsy({title: 'tipsy-title', trigger: 'manual', html: true, gravity: 's'});
            }

            if (UI.primaryColorProperty) {
                UI.changeColorComponentPrimary();
            }
            if (UI.secondaryColorProperty) {
                UI.changeColorComponentSecondary();
            }
            return {d: obj.get(0), id: id};
        }
    };
    window.Validator = {
        isFloat: function (string) {
            return Number(string) === string && string % 1 !== 0;
        },
        isInteger: function (string) {
            return Number(string) === string && string % 1 === 0;
        }
    };

})();