
<!DOCTYPE html>
<?php
    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    $email = $_SESSION['email'];
     
    $controlador = new ControladorUsuario();
    if(!$controlador->setUser($email)) {
        header("Location: login.php");
    }
    if($controlador->ehAluno()){
        header("Location: profile.php");
    }
    $imageurl = $controlador->getImage(); 
    $index =0;
    
    if(isset($_GET['index'])) {
        $index = $_GET['index'];
    } else{
        $_GET['index']=0;
    }

    include './controladores/Professor.php';
    include './controladores/Turma.php';
    include './entidades/MaterialDidatico.php';
    

    $controlador = $controlador->getProfessor();
    $turma = $controlador->getTurmaByIndex($index);
    $details = $turma->getDescricaoTurma();
    $materiaisdidaticos = $turma->listarMateriaisDidaticos();
    $title = $details['disciplina_nome'].' ('.$details['curso_sigla'].') - '.$turma->getAno();   
    

    if($imageurl!=null && $imageurl!=='')
    {
        $imageurl = $imageurl.'?='.rand();
    }
    else
    {
        $imageurl = 'images/userdefault.png';
    }
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Materiais Didáticos - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link href="css/bootstrap.min.css" rel="stylesheet"/>
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/materialdidaticoeditstyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
            <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Material Didático</p>
                <p>Cadilag</p>
            </div>
            <div class='title'>
                <p><?= $title; ?></p>
            </div> 
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
            
        </div>
        <div class="content">
            <button class="pure-button" onclick="window.location='./class.php?index=<?= $index ?>';">Voltar para a Turma</button>
            <div class="area">
                <div class="novo">
                    <div class="title"><p>Incluir</p></div>
                    <form class="pure-form" action="./postNovoMaterial.php" method="POST" enctype="multipart/form-data">
                        <input type="hidden" name="index" value="<?= $index ?>"/>
                        <div class="label"><p>Título</p></div>
                        <input required="required" autocomplete="off" id="titulo" maxlength="45" name="titulo" placeholder="Máximo 45 caracteres"/>
                        <div id="counttitulo"><p>0/45</p></div>
                        <div class="label"><p>Descricao</p></div>
                        <textarea required="required" id="detalhes" name="detalhes"></textarea>
                        <div class="label"><p>Arquivo</p></div>
                        <input required="required" type="file" name="arquivo"/>
                        <button class="pure-button pure-button-primary">Carregar novo Material</button>
                    </form>
                </div>
                <div class="lista">
                    <div class="title"><p>Materiais</p></div>
                    <div class="columnnames">
                        <div class="columnntitulo">Título</div>
                        <div class="columnndata">Data</div>
                        <div class="columnnhora">Hora</div>
                    </div>
                    <div class="materiaistable">
                        <?PHP if(!empty($materiaisdidaticos)): ?>
                            <?PHP foreach($materiaisdidaticos as $i=>$material): ?>
                                <div class="material <?= ($i%2===0?'even':'odd') ?>" onclick="openMaterial(<?= $i ?>)">
                                    <div class="columnntitulo"><?= $material->getTitulo() ?></div>
                                    <div class="columnndata"><?= $material->getDataFormatada() ?></div>
                                    <div class="columnnhora"><?= $material->getHoraMinimizada() ?></div>
                                </div>
                            <?PHP endforeach; ?>
                        <?PHP else: ?>
                            <p id="empty">Vazio</p>
                        <?PHP endif; ?>
                    </div>
                </div>
            </div>
        </div>
        <?PHP foreach($materiaisdidaticos as $i=>$material): ?>
        <div class="materiadetails" style="display:none" id="<?= $i ?>">
            <div class="title">Detalhes</div>
            <div class="label"><p>Título</p></div>
            <div class="value"><p><?= $material->getTitulo() ?></p></div>
            <div class="label"><p>Detalhes</p></div>
            <div class="value"><p><?= $material->getDetalhes() ?></p></div>
            <div class="label"><p>Nome</p></div>
            <div class="value"><p><?= $material->getPureNome() ?></p></div>
            <div class="label"><p>Tamanho</p></div>
            <div class="value"><p><?= $material->getSize() ?></p></div>
            <form method="POST">
                <input type="hidden" name="index" value="<?= $index ?>"/>
                <input type="hidden" name="id" value="<?= $material->getId() ?>"/>
                <button formaction="./downloadMaterial.php" class="pure-button pure-button-primary download">Download</button>
                <button formaction="./postDeleteMaterial.php" class="pure-button delete">Deletar</button>
            </form>
        </div>
        <?PHP endforeach; ?>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location='./profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location='./editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location='./arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location='./class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location='./novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location='./closesession.php';"><p>Sair</p></div>

        </div>
        <script>
        function openMaterial(id){
            $(".materiadetails").fadeOut(250);
            $(".materiadetails#"+id).fadeIn(250);    
        }
        $("#titulo").keypress(function(){
            $("#counttitulo p").html($(this).val().length+'/45');
        });
        $("#titulo").keyup(function(){
            $("#counttitulo p").html($(this).val().length+'/45');
        });
        
        $("#gotohub").click(function(){
            $("#huboptions").fadeToggle(100); 
        });

        </script>
    </body>
</html>
