
<!DOCTYPE html>
<?php
    session_start();
    if(!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    $email = $_SESSION['email'];
     
    $controlador = new ControladorUsuario();
    if(!$controlador->setUser($email)) {
        header("Location: login.php");
    }
    $imageurl = $controlador->getImage(); 
    $index =0;
    
    if(isset($_GET['index'])) {
        $index = $_GET['index'];
    } else{
        $_GET['index']=0;
    }

    if(isset($_GET['id'])) {
        $id = $_GET['id'];
    } else {
        $_GET['id']=0;
    }
    
    include './controladores/Turma.php';
    include './entidades/MaterialDidatico.php';
    

    if($controlador->ehAluno()) {
        include './controladores/Aluno.php';
        $controlador = $controlador->getAluno();
        $turma = $controlador->getTurma();
        if($turma===null)
        {
            header("Location: profile.php");
        }
    } else {
        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();
        $turma = $controlador->getTurmaByIndex($index);
    }
    
    $details = $turma->getDescricaoTurma();
    $materialdidatico = $turma->getMaterial($id);
    $title = $details['disciplina_nome'].' ('.$details['curso_sigla'].') - '.$turma->getAno();   
    
    if($imageurl!=null && $imageurl!=='') {
        $imageurl = $imageurl.'?='.rand();
    } else {
        $imageurl = 'images/userdefault.png';
    }
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Materiais Didáticos - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilaginverted.svg">
        <link href="css/bootstrap.min.css" rel="stylesheet"/>
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/materialdidaticoview.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Material Didático</p>
                <p>Cadilag</p>
            </div>
            <div class='title'>
                <p><?= $title; ?></p>
            </div> 
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
            
        </div>
        <div class="content">
            <button class="pure-button" onclick="window.location='./class.php?index=<?= $index ?>';">Voltar para a Turma</button>
            <div class="wrapper">
                <div class="arquivo">
                    <div class="title"><p>Arquivo</p></div>
                    <div class="label"><p>Nome</p></div>
                    <div class="value"><p><?= $materialdidatico->getPureNome() ?></p></div>
                    <div class="label"><p>Extensão</p></div>
                    <div class="value"><p><?= $materialdidatico->getExtension() ?></p></div>
                    <div class="label"><p>Tamanho</p></div>
                    <div class="value"><p><?= $materialdidatico->getSize() ?></p></div>
                    <form method="POST">
                        <input type="hidden" name="index" value="<?= $index ?>"/>
                        <input type="hidden" name="id" value="<?= $materialdidatico->getId() ?>"/>
                        <button formaction="./downloadMaterial.php" class="pure-button-primary download">Download</button>
                    </form>
                </div>
                <div class="descricao">
                    <div class="title"><p>Descrição</p></div>
                    <div class="label"><p>Título</p></div>
                    <div class="value"><p><?= $materialdidatico->getTitulo() ?></p></div>
                    <div class="label"><p>Detalhes</p></div>
                    <div class="value"><p><?= nl2br($materialdidatico->getDetalhes()) ?></p></div>
                    <div class="datetime">
                        <p><br><b>Última Revisão: </b><?= $materialdidatico->getDataFormatada() ?><b> ás </b><?= $materialdidatico->getHoraMinimizada() ?></p>
                    </div>
                </div>
            </div> 
        </div>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location='./profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location='./editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location='./arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location='./class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location='./novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location='./closesession.php';"><p>Sair</p></div>
        </div>
        <script>
        
        $("#gotohub").click(function(){
            $("#huboptions").fadeToggle(100); 
        });

        </script>
    </body>
</html>
