
<!DOCTYPE html>
<?php
session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    header("Location: login.php");
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
include './controladores/Professor.php';
include './controladores/Turma.php';

$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    header("Location: login.php");
}

if ($controlador->ehAluno()) {
    header("Location: profile.php");
}

$imageurl = $controlador->getImage();
$index = 0;

if (isset($_GET['index'])) {
    $index = $_GET['index'];
} else {
    $_GET['index'] = 0;
}


$controlador = $controlador->getProfessor();
$turma = $controlador->getTurmaByIndex($index);
$details = $turma->getDescricaoTurma();
$title = $details['disciplina_nome'] . ' (' . $details['curso_sigla'] . ') - ' . $turma->getAno();

if ($imageurl != null && $imageurl != '') {
    $imageurl = $imageurl . '?=' . rand();
} else {
    $imageurl = 'images/userdefault.png';
}
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Nova atividade - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/novaatividadestyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Nova atividade</p>
                <p>Cadilag</p>
            </div>
            <div class='title'>
                <p><?= $title; ?></p>
            </div> 
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="content">
            <div class="area">
                <form action="postNovaAtividade.php" method="POST" class="pure-form">
                    <div class="title"><p>Descrição</p></div>
                    <div class="subtitle"><p>Insira abaixo o <b>TITULO</b> da Atividade (Máximo 45 caracteres)</p></div>
                    <p id="titulo"><input autocomplete="off" name="titulo" maxlength="45" required="required"/></p>
                    <div id="counttitulo"><p>0/45</p></div>
                    <div class="subtitle"><p>Insira abaixo os <b>DETALHES</b> sobre nova atividade</p></div>
                    <input name="index" type="hidden" value="<?= $index; ?>"/>
                    <p><textarea name="texto" required="required"></textarea></p>
                    <div class="subtitle"><p>Selecione abaixo a <b>DATA</b> do término da atividade</p></div>
                    <div style="color:white;font-size: 12px;text-align: center;margin-left: 5px;"><div style='width: 70px; float: left'>Dia</div><div style='width: 120px;float: left;margin-left: 10px;'>Mes</div><div style='width: 100px;float: left;margin-left: 10px;'>Ano</div></div>
                    <p style='margin-left: 5px;'>
                        <input value="01" required="required" type="number" min='1' max='31' style='width: 70px;text-align: center;' id="dia" name='dia'/>
                        <select style='color:black;width: 120px;margin-left: 10px;' id="mes" name='mes'>
                            <option value="01">Janeiro</option>
                            <option value="02">Fevereiro</option>
                            <option value="03">Março</option>
                            <option value="04">Abril</option>
                            <option value="05">Maio</option>
                            <option value="06">Junho</option>
                            <option value="07">Julho</option>
                            <option value="08">Agosto</option>
                            <option value="09">Setembro</option>
                            <option value="10">Outubro</option>
                            <option value="11">Novembro</option>
                            <option value="12">Dezembro</option>
                        </select>
                        <input value=2016 required="required" min='2016' max='3000' type="number" id="ano" style='width: 100px;margin-left: 10px;text-align: center;' name='ano'/></p>
                    <p><button type="submit" class="pure-button pure-button-primary">Criar</button><button class="pure-button" type="button" onclick="window.location = './class.php?index=<?= $index; ?>';">Cancelar</button></p>
                </form>
            </div>

            <div class="warning">
                <h2>Dicas</h2>
                <p>
                    Você pode editar qualquer campo<br>em qualquer momento mais tarde<br>
                    <br>Você pode utilizar as TAGS no campo DETALHES: 
                    <br>&ltb&gt para escrever em <b>negrito</b>
                    <br>&lti&gt para escrever em <i>italico</i> 
                    <br>&ltbig&gt para letras maiores
                    <br>&ltsmall&gt para letras menores
                    <br>&ltcenter&gt para alinha uma linha
                    <br>&lth1&gt ... &lth6&gt para Titulos<br>
                    <br>Exemplo: &lti&gt&ltbig&gt texto &lt/big&gt&lt/i&gt -> <i><big>texto</big></i> <br>
                    <br>Não utilizar tags PHP ou atributos em TAG HTML
                    <br>Utilizar Espaço ao lado dos sibolos: '<' (maior) e '>' (menor)
                </p>
            </div>

        </div>

        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location = './profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location = './editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location = './arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location = './class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location = './novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location = './closesession.php';"><p>Sair</p></div>
        </div>
        <script>
            updateMaxDia = function () {
                var mes = parseInt($("#mes").val());
                var dia = parseInt($("#dia").val());
                var ano = parseInt($("#ano").val());
                
                switch (mes)
                {
                    case 1:
                    case 3:
                    case 5:
                    case 7:
                    case 8:
                    case 10:
                    case 12:
                        $("#dia").attr('max', '31');
                        break;
                    case 2:
                        if ((ano%4===0 && ano%100!==0) || ano%400===0)
                            $("#dia").attr('max', '29');
                        else
                            $("#dia").attr('max', '28');
                        break;
                    case 4:
                    case 6:
                    case 9:
                    case 11:
                        $("#dia").attr('max', '30');
                        break;
                }
                
                var maxdia = parseInt($("#dia").attr("max"));
                
                if(dia>maxdia)
                    $("#dia").val(maxdia);
                
            };
            
            $("#mes").change(function () {
                updateMaxDia();
            });
            
            $("#ano").change(function () {
                updateMaxDia();
            });

            $("#titulo input").keypress(function () {
                $("#counttitulo p").html($(this).val().length + '/45');
            });
            $("#titulo input").keyup(function () {
                $("#counttitulo p").html($(this).val().length + '/45');
            });

            $("#gotohub").click(function () {
                $("#huboptions").fadeToggle(100);
            });

        </script>
    </body>
</html>
