
<!DOCTYPE html>
<?php
        session_start();
    if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
        header("Location: login.php");
    }
    include './config/Database.php';
    include './controladores/ControladorUsuario.php';
    include './controladores/Turma.php';
    $email = $_SESSION['email'];
    $sennha = $_SESSION['senha'];
    $controlador = new ControladorUsuario();
    $controlador->setUser($email);

    $imageurl = $controlador->getImage();
    $title = $controlador->getTitleName();
    $isAluno = $controlador->ehAluno();
    if ($isAluno) {
        include './controladores/Aluno.php';
        $controlador = $controlador->getAluno();
        $turma = $controlador->getTurma();
        if ($turma != null) {
            $details = $turma->getDescricaoTurma();
        }
        if (isset($_GET['autocomplete'])) {
            $autocomplete = '0';
        } else {
            $autocomplete = null;
        }
    } else {
        include './controladores/Professor.php';
        $controlador = $controlador->getProfessor();
        $turmas = $controlador->getTurmas();
        if (isset($_GET['autocomplete'])) {
            $autocomplete = $_GET['autocomplete'];
        } else {
            $autocomplete = null;
        }
    }

    if ($imageurl != null && $imageurl !== '') {
        $imageurl = $imageurl . '?=' . rand();
    } else {
        $imageurl = 'images/userdefault.png';
    }
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Novo Tópico</title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/novotopicostyle.css" rel="stylesheet"/>
        <link href="css/bootstrap-switch.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
        <script src="js/bootstrap-switch.js"></script> 
    <body>
        <div class="area">
            <div id="count">
                <p>0/100</p>
            </div>
            <div id="label">
                <p style="margin-top: 20px;">Título</p>
                <p>Texto</p>
            </div>
            <form class="pure-form" action="./postTopico.php" method="POST">
                <input autocomplete="off" placeholder="Máximo 100 caracteres" maxlength="100" name='titulo' type="text" required="required">
                <textarea name='texto' required="required" ></textarea>
                <p>
                    <label for="turmaselector">Vincular á turma: </label>
                    <select name="turma" id="turmaselector">
                        <option value="null">Nenhuma</option>
                        <?php if($isAluno): ?>
                            <?PHP if($turma!=null): ?>
                                <option value="0"><?= $details['disciplina_nome']?> (<?= $details['curso_sigla']?>) - <?= $turma->getAno() ?></option>
                            <?PHP endif; ?>
                        <?PHP else: ?>
                            <?PHP foreach($turmas as $i=>$turma): $details = $turma->getDescricaoTurma();?>
                                <option value="<?= $i ?>"><?= $details['disciplina_nome']?> (<?= $details['curso_sigla']?>) - <?= $turma->getAno() ?></option>
                            <?PHP endforeach; ?>
                        <?PHP endif; ?>
                    </select>
                </p>
                <p>
                    <label for="particular">Visibilidade:</label>
                    <input type="checkbox" id="particular" name="particular" disabled=""/>
                </p>
                <p>
                    <label for="anonimo">Assinatura:</label>
                    <input type="checkbox" id="anonimo" name="anonimo"/>
                    <label style="margin-left: 20px;" for="report">Tipo:</label>
                    <input type="checkbox" id="report" name="report"/>
                </p>
                <button class="pure-button pure-button-primary" id='post'>Publicar</button>
                <button class="pure-button" onclick="window.location='./profile.php';"  type='button' >Cancelar</button>
            </form>
        </div>
        <div class="warning">
            <h2>Dicas</h2>
            <p>
                Você pode utilizar as TAGS: 
                <br>&ltb&gt para escrever em <b>negrito</b>
                <br>&lti&gt para escrever em <i>italico</i> 
                <br>&ltbig&gt para letras maiores
                <br>&ltsmall&gt para letras menores
                <br>&ltcenter&gt para centrar uma linha
                <br>&lth1&gt ... &lth6&gt para Titulos<br>
                <br>Exemplo: &lti&gt&ltbig&gt texto &lt/big&gt&lt/i&gt -> <i><big>texto</big></i> <br>
                <br>Não utilizar tags PHP ou atributos em TAG HTML
                <br>Utilizar Espaço ao lado dos sinais: < (maior) ou > (menor)<br>
                <br>Se o tópico for ofensivo será removido<br>
                <br>Tópicos de Report serão visualizados pelos Admistradores, 
                <br>e servem de auxílio para encontrar falhas 
                <br>ou trazer melhorias para sistema com dicas
                <br>Sinta-se a vontade &#9787;, e se preferir,
                <br>você pode criar um tópico Anônimo
            </p>
        </div>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location='./profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location='./editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location='./arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="window.location='./class.php';"><p>Turma</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location='./closesession.php';"><p>Sair</p></div>
        </div>

        <div class='topbar'>
            <a href="./profile.php"><img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/></a>
            <div class="subtitle"><p>Novo Tópico</p><p>Cadilag</p></div>
            <div class='title'><p> <?= $title; ?></p></div> 
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>

        <script>
        $.fn.bootstrapSwitch.defaults.offColor='success';
        $.fn.bootstrapSwitch.defaults.offText='Pública';
        $.fn.bootstrapSwitch.defaults.onText='Somente Turma';
        $.fn.bootstrapSwitch.defaults.handleWidth='120px';
        $("#particular").bootstrapSwitch();
        
        $.fn.bootstrapSwitch.defaults.offText='Visível';
        $.fn.bootstrapSwitch.defaults.onText='Anônima';
        $.fn.bootstrapSwitch.defaults.handleWidth='60px';
        $("#anonimo").bootstrapSwitch();

        $.fn.bootstrapSwitch.defaults.offText='Padrão';
        $.fn.bootstrapSwitch.defaults.onText='Report';
        $.fn.bootstrapSwitch.defaults.handleWidth='60px';
        $("#report").bootstrapSwitch();
    
        <?PHP if($autocomplete!==null): ?>
            $("#turmaselector").val('<?= ($autocomplete!==null?$autocomplete:'null') ?>');
            $("#particular").bootstrapSwitch('disabled',false);
        <?PHP endif; ?>
        $("#turmaselector").change(function(){
            
            if($(this).val()!=='null')
            {
                $("#particular").bootstrapSwitch('disabled',false);
            }
            else
            {
                $("#particular").bootstrapSwitch('state',false);
                $("#particular").bootstrapSwitch('disabled',true);
            }
        });
        
        $("input[name='titulo']").keypress(function(){
           $("#count p").html($(this).val().length+'/100'); 
        });
        
        $("input[name='titulo']").keyup(function(){
           $("#count p").html($(this).val().length+'/100'); 
        });
        
        $("#gotohub").click(function(){
            $("#huboptions").fadeToggle(100); 
        });
        

        </script>
    </body>
</html>
