<?php

session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    echo 'Erro: Sessão fechada!';
    return;
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
$email = $_SESSION['email'];
$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    echo '<p>Erro: Sessão aberta mas usuário não cadastrado!</p> <form action="./closesession.php"><button>Fechar Sessão</button></form>';
    return;
}

if (!isset($_POST['titulo']) || !isset($_POST['texto']) || !isset($_POST['turma'])) {
    echo 'Erro: POST titulo ou texto não encontrados';
    return;
}

$title = strip_tags($_POST['titulo']);
$text = preg_replace("/<([a-z][a-z0-9]*)[^>]*?(\/?)>/i", '<$1$2>', strip_tags($_POST['texto'], '<b><i><big><small><center><h1><h2><h3><h4><h5><h6>'));
$indexturma = $_POST['turma'];

//COMPORTAMENTO INESPERADO{
$particular = isset($_POST['particular']);
$report = isset($_POST['report']);
$anonimo = isset($_POST['anonimo']);
//}
$isAluno = $controlador->ehAluno();

if ($indexturma === 'null') {
    $idturma = null;
} else {
    include './controladores/Turma.php';
    if ($isAluno) {
        include './controladores/Aluno.php';
        $aluno = $controlador->getAluno();
        $turma = $aluno->getTurma();
    } else {
        include './controladores/Professor.php';
        $professor = $controlador->getProfessor();
        $turmas = $professor->getTurmas();

        if ((int) $indexturma > count($turmas)) {
            echo 'Erro: Turma não encontrada';
            return;
        }
        $turma = $turmas[(int) $indexturma];
    }
    $idturma = $turma->getIdturma();
}

if (!$controlador->novoTopico($title, $text, $particular, $anonimo, $report, $idturma)) {
    echo 'Falha SQL';
    return;
}

header("Location: profile.php");


