<!DOCTYPE html>
<?php
/**
 * Tópicos do Usuário
 */
session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    header("Location: login.php");
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
include './entidades/Resposta.php';
$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    header("Location: login.php");
}

$imageurl = $controlador->getImage();
$title = $controlador->getTitleName();
$gruporespostas = $controlador->listarRespostasDoUsuario();
if ($imageurl != null && $imageurl !== '') {
    $imageurl = $imageurl . '?=' . rand();
} else {
    $imageurl = 'images/userdefault.png';
}
?>
<html>
    <head>
        <meta charset="UTF-8" />
        <title>Suas Respostas - <?= $title; ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/repostasstyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    </head>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Suas Respostas</p>
                <p>Cadilag</p>
            </div>
            <button class="pure-button " onclick="window.location = './profile.php';">Voltar</button>
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="content">
            <div class="respostasarea">
                <div class="title"><p>Respostas</p></div>
                <div class="repostas">
<?PHP foreach ($gruporespostas as $grupo): try {
        $r = $grupo[0]; ?>
                            <div class="grupo">
                                <div class="toparea">
                                    <div class="assunto">
                                        <div class="label">Assunto</div>
        <?= $r->getTopicoAssunto() ?>
                                    </div>
                                    <div class="info">
                                        <div class="label"><p>Autor do Tópico</p></div>
                                        <div class="userlabel">
                                            <img src="<?= $r->getUserImage() ?>" alt="foto do criador do tópico" width="50" height="50"/>
                                            <div class="title"><p><?= $controlador->getTitleNameBy($r->getUserNome(), $r->getUserSobrenome(), $r->getUserApelido(), $r->getUserEmail()); ?></p></div>
                                        </div>
                                        <a class="pure-button showbtn" href="./topicoview.php?id=<?= $r->getTopicoId() ?>">Visualizar Tópico Completo</a>
                                    </div>
                                </div>
        <?PHP foreach ($grupo as $resposta): try { ?>
                                        <div class="resposta">
                                            <div class="vote" >
                                                <div class="title"><p>Votos</p></div>
                                                <div title="Votar Positivo" class="up"><p><?= $resposta->getVotosPositivos() ?></p></div>
                                                <div title="Votar Negativo" class="down"><p><?= $resposta->getVotosNegativos() ?></p></div>
                                            </div>
                                            <div class="text"><p><?= nl2br($resposta->getTexto()) ?></p></div>
                                            <div class="data"><p><b>Última revisão: </b><?= $resposta->getDataFormatada() ?><b> ás </b><?= $resposta->getHora() ?></p></div>                            
                                        </div>
            <?PHP } catch (Exception $e) {
                echo $e;
            } endforeach; ?>
                            </div>
                            <?PHP } catch (Exception $e) {
                                echo $e;
                            } endforeach; ?>
                </div>
            </div>
        </div>
        <div class="editarea" style="display: none;">
            <div class="title"><p>Editar Resposta</p></div>
            <form action="postUpdateResposta.php" method="POST" id="editResposta" class="pure-form">
                <input type="hidden" name="id" />
                <textarea name="text" required="required"></textarea>
                <button class="pure-button pure-button-primary">Alterar</button>
                <button type="button" onclick="$('.editarea').fadeOut(100);" class="pure-button">Cancelar</button>
            </form>
        </div>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location = './profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location = './editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location='./html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="window.location = './class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location = './arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location = './novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location = './closesession.php';"><p>Sair</p></div>
        </div>
        <script>
            $("#gotohub").click(function () {
                $("#huboptions").fadeToggle(100);
            });
        </script>
    </body>
</html>
