
<!DOCTYPE html>
<?php
session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    header("Location: login.php");
}
include './config/Database.php';
include './controladores/ControladorUsuario.php';
include './entidades/Topico.php';
$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    header("Location: login.php");
}

$isAluno = $controlador->ehAluno();
include './controladores/Turma.php';
if ($isAluno) {
    include './controladores/Aluno.php';
    $aluno = $controlador->getAluno();
    $turma = $aluno->getTurma();
} else {
    include './controladores/Professor.php';
    $professor = $controlador->getProfessor();
    if (isset($_GET['index'])) {
        $index = (int) $_GET['index'];
    } else {
        header('location: ./profile.php');
    }

    $turma = $professor->getTurmaByIndex($index);
}

$details = $turma->getDescricaoTurma();
$imageurl = $controlador->getImage();
$title = $controlador->getTitleName();
$total = $turma->getTotalTopicos();
$topicos = $turma->listarTopicos(0, $total);
if ($total !== count($topicos)) {
    echo 'Falha na contagem dos tópicos, Atualize a página!';
}
if ($imageurl != null && $imageurl !== '') {
    $imageurl = $imageurl . '?=' . rand();
} else {
    $imageurl = 'images/userdefault.png';
}
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title> Tópicos Vinculados - <?= $details['disciplina_nome'] ?> (<?= $details['curso_sigla'] ?>) - <?= $turma->getAno() ?> </title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/topicosstyle.css" rel="stylesheet"/>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Tópicos Vinculados</p>
                <p>Cadilag</p>
            </div>
            <a class="pure-button " href="./class.php<?= (!$isAluno ? '?index=' . $index : '') ?>">Voltar para a Turma</a>
            <a class="pure-button pure-button-primary" href="./novotopico.php?autocomplete=<?= (!$isAluno ? $index : '0') ?>">Criar novo tópico vinculado</a>
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="area">
            <div class="title"><p>Tópicos (<?= $total; ?>)</p></div>
            <div class="topicos">
<?PHP if (!empty($topicos)): ?>
    <?PHP foreach ($topicos as $topico): try { ?>
                            <a href="./topicoview.php?id=<?= $topico->getId() ?>">
                                <div class="topico">
                                    <div class="title"><p><?= $topico->getTitulo() ?></p></div>
                                    <div class="comment"><p><?= $controlador->getTotalRespostaTopico($topico->getId()) ?></p></div>                               
                                    <div class="time"><p><?= $topico->getDataFormatada() ?> ás <?= $topico->getHoraMinimizada() ?></p></div>
            <?PHP if ($topico->getParticular()): ?>
                                        <div class="locked"><p></p></div>
            <?PHP endif; ?>
                                </div>
                            </a>
                        <?PHP } catch (Exception $e) {
                            echo $e;
                        } endforeach; ?>
<?PHP else: ?>
                    <p id="empty">Vazio</p>
<?PHP endif; ?>
            </div>
        </div>
        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location = './profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location = './editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location = './class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location = './arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location = './novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location = './closesession.php';"><p>Sair</p></div>
        </div>
        <script>
            $("#gotohub").click(function () {
                $("#huboptions").fadeToggle(100);
            });
        </script>
    </body>
</html>
