
<!DOCTYPE html>
<?php
session_start();
if (!isset($_SESSION['email']) || !isset($_SESSION['senha'])) {
    header("Location: login.php");
}
include './config/Database.php';
include './entidades/Topico.php';
include './entidades/Resposta.php';
include './controladores/ControladorUsuario.php';
$email = $_SESSION['email'];

$controlador = new ControladorUsuario();
if (!$controlador->setUser($email)) {
    header("Location: login.php");
}

if (!isset($_GET['id'])) {
    header("Location: profile.php");
}

$id = (int) $_GET['id'];
$topico = $controlador->getTopico($id);
$idturmatopico = $topico->getTurma();
include './controladores/Turma.php';
if ($controlador->ehAluno()) {
    include './controladores/Aluno.php';

    $controlador = $controlador->getAluno();
    $turma = $controlador->getTurma();
} else {
    include './controladores/Professor.php';
    $controlador = $controlador->getProfessor();
    $acesso = $controlador->possuiAcesso();
}

if ($idturmatopico !== null) {
    $turmatopico = $controlador->getTurmaById($idturmatopico);
    $details = $turmatopico->getDescricaoTurma();
}

$imageurl = $controlador->getImage();
$respostas = array_reverse($controlador->listarRespotasAoTopico($id));

if ($imageurl != null && $imageurl !== '') {
    $imageurl = $imageurl . '?=' . rand();
} else {
    $imageurl = 'images/userdefault.png';
}
?>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8" />
        <title>Tópico - <?= $topico->getTitulo(); ?></title>
        <link rel="shortcut icon" href="images/cadilag.svg">
        <link rel="stylesheet" href="css/yui.yahooapis.com_pure_0.6.0_pure-min.css"/>
        <link href="css/genericstyle.css" rel="stylesheet"/>
        <link href="css/topicoviewstyle.css" rel="stylesheet"/>
        <link href="css/sweetalert.css" rel="stylesheet"/>
        <script src="js/sweetalert.min.js"></script>
        <script src="js/jquery-3.1.1.min.js"></script>
        <script src="js/jquery-ui.min.js"></script>
    <body>
        <div class='topbar'>
            <a href="./profile.php">
                <img src='images/cadilaginverted.svg' alt='cadilag icone' id='icon'/>
            </a>
            <div class="subtitle">
                <p>Tópico</p>
                <p>Cadilag</p>
            </div>
            <a href="./profile.php"><button class="pure-button" id="voltarprincipal">Voltar para o Principal</button></a>
            <div id='gotohub'>
                <p>HUB</p>
                <img id='imgUser' alt='Imagem do Perfil' src='<?= $imageurl ?>'/>
            </div>
        </div>
        <div class="area">
            <div class="topico">
                <div class="description">
                    <div class="label"><p>Titulo</p></div>
                    <div class="title"><p><?= $topico->getTitulo() ?></p></div>
                    <div class="data"><p><b>Última revisão:</b> <?= $topico->getDataFormatada() ?> <b>ás</b> <?= $topico->getHoraMinimizada() ?></p></div>
                </div>
                <div class="userinfo">

                    <div class="label"><p>Criado por</p></div>
                    <div class="userlabel">
                        <?PHP if (!$topico->getAnonimo()): ?>
                            <img alt="Foto de <?= $topico->getTitleNameUser() ?>" src="<?= $topico->getUserImage() ?>?=<?= rand() ?>" width="50" height="50"/>
                        <?PHP else: ?>
                            <img alt="Foto de Anônimo" src="./images/userdefault.png" width="50" height="50"/>
                        <?PHP endif; ?>
                        <div class='title'><p><?= $topico->getTitleNameUser(); ?></p></div>
                    </div>

                    <div class="locked">
                        <div class="label"><p>Visibilidade</p></div>
                        <div class="value"><p><?= ($topico->getParticular() ? 'Somente para a turma' : 'Pública') ?></p></div>
                    </div>
                    <div class="type">
                        <div class="label"><p>Tipo</p></div>
                        <div class="value"><p><?= ($topico->getReport() ? 'Report' : 'Padrão') ?></p></div>
                    </div>
                    <?PHP if ($idturmatopico !== null): ?>
                        <div class="bound">
                            <div class="label"><p>Vinculado á Turma</p></div>
                            <div class="value"><p><?= $details['disciplina_nome'] ?> (<?= $details['curso_sigla'] ?>) - <?= $turmatopico->getAno() ?></p></div>
                        </div>
                    <?PHP endif; ?>
                    <?PHP if ($topico->getIduser() === (int) $controlador->getUserId()): ?>
                        <div class="label"><p>Opções</p></div>
                        <button class="editbtn" onclick="window.location = './topicoedit.php?id=<?= $id ?>'" >Editar</button>                        
                        <button type="button" class="deletebtn" onclick="deletarTopico(<?= $id ?>)">Deletar</button>
                    <?PHP endif; ?>
                </div>
                <div class='text'>
                    <div class="label"><p>Texto</p></div>
                    <p><?= nl2br($topico->getTexto()) ?></p>
                </div>

            </div>
            <div class="respostasarea">
                <div id="contresposta"><p>Total</p><p id="cont"><?= count($respostas) ?></p></div>
                <div class="title"><p>Respostas</p></div>
                <div class="repostas">
                    <?PHP foreach ($respostas as $resposta): try { ?>
                            <div class="resposta" id="<?= $resposta->getId() ?>" <?= ($controlador->getUserId() === $resposta->getUserId() ? ' editable="editable"' : '') ?>>
                                <div class="vote" <?= ((int) $resposta->getUserId() === (int) $controlador->getUserId() ? 'disabled="disabled"' : '') ?> >
                                    <div class="title"><p>Votos</p></div>
                                    <?PHP if ($resposta->getVoto() !== null): ?>
                                        <div title="Votar Positivo" class="up" <?= ($resposta->getVoto() ? 'voted="voted"' : '') ?> ><p><?= $resposta->getVotosPositivos() ?></p></div>
                                        <div title="Votar Negativo" class="down" <?= (!$resposta->getVoto() ? 'voted="voted"' : '') ?>><p><?= $resposta->getVotosNegativos() ?></p></div>
                                    <?PHP else: ?>
                                        <div title="Votar Positivo" class="up"><p><?= $resposta->getVotosPositivos() ?></p></div>
                                        <div title="Votar Negativo" class="down"><p><?= $resposta->getVotosNegativos() ?></p></div>
                                    <?PHP endif; ?>
                                </div>
                                <div class="info">
                                    <div class="label"><p>Respondido por</p></div>
                                    <div class="userlabel">
                                        <img src="<?= $resposta->getUserImage() ?>" alt="foto do criador do tópico" width="50" height="50"/>
                                        <?PHP if (!$topico->getAnonimo() && $resposta->getUserId() == $topico->getIduser()): ?>
                                            <div class="title own">
                                                <?= ($resposta->getUserId() == $controlador->getUserId()) ? "Você" : $controlador->getTitleNameBy($resposta->getUserNome(), $resposta->getUserSobrenome(), $resposta->getUserApelido(), $resposta->getUserEmail()); ?>
                                            </div>
                                            <div class="subtitle">
                                                Autor do Tópico
                                            </div>
                                        <?PHP else : ?>
                                            <div class="title">
                                                <?= ($resposta->getUserId() == $controlador->getUserId()) ? "Você" : $controlador->getTitleNameBy($resposta->getUserNome(), $resposta->getUserSobrenome(), $resposta->getUserApelido(), $resposta->getUserEmail()); ?>
                                            </div>
                                        <?PHP endif; ?>
                                    </div>
                                    <?PHP if ($controlador->getUserId() === $resposta->getUserId()): ?>
                                        <button class="pure-button editbtn" >Editar</button>
                                        <button onclick="removeResposta(<?= $resposta->getId() ?>)" class="pure-button deletebtn">Remover</button>
                                    <?PHP endif; ?>
                                </div>
                                <div class="text"><p><?= nl2br($resposta->getTexto()) ?></p></div>
                                <div class="data"><p><b>Última revisão: </b><?= $resposta->getDataFormatada() ?><b> ás </b><?= $resposta->getHora() ?></p></div>                            


                            </div>
                            <?PHP
                        } catch (Exception $e) {
                            echo $e;
                        } endforeach;
                    ?>
                </div>
                <form action="postNovaResposta.php" method="POST" id="novaResposta" class="pure-form">
                    <input type="hidden" name="id" value="<?= $id; ?>"/>
                    <textarea required="required" placeholder="Digite aqui uma nova Resposta!" name="text" ></textarea>
                    <button class="pure-button pure-button-primary">Publicar</button>
                </form>
            </div>

        </div>

        <div class="editarea" style="display: none;">
            <div class="title"><p>Editar Resposta</p></div>
            <form action="postUpdateResposta.php" method="POST" id="editResposta" class="pure-form">
                <input type="hidden" name="id" />
                <input type="hidden" name="index" value="<?= $id; ?>"/>
                <textarea name="text" required="required"></textarea>
                <button class="pure-button pure-button-primary">Alterar</button>
                <button type="button" onclick="$('.editarea').fadeOut(100);" class="pure-button">Cancelar</button>
            </form>
        </div>

        <div id='huboptions' style="display:none;">
            <div class='option' onclick="window.location = './profile.php';"><p>Principal</p></div>
            <div class='option' onclick="window.location = './editprofile.php';"><p>Editar Perfil</p></div>
            <div class='option' onclick="window.location = './html/CadilagStructs'"><p>Estruturas</p></div>
            <div class='option' onclick="window.location = './class.php';"><p>Turma</p></div>
            <div class='option' onclick="window.location = './arquivos.php';"><p>Arquivos</p></div>
            <div class='option' onclick="window.location = './novotopico.php';"><p>Novo Tópico</p></div>
            <div class='option' onclick="localStorage.setItem('emailCadilag', null);localStorage.setItem('senhaCadilag', null); window.location = './closesession.php';"><p>Sair</p></div>
        </div>
        <script>
            <?PHP if ($topico->getIduser() === (int) $controlador->getUserId()): ?>
                function deletarTopico(id) {
                    swal({
                        title: "Você tem certeza?",
                        text: "Deseja remover por completo o tópico!",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: "Remover",
                        cancelButtonText: "Cancelar",
                        closeOnConfirm: false,
                        closeOnCancel: true},
                            function (isConfirm)
                            {
                                if (isConfirm) {

                                    var data = {"id": id};
                                    $.post("./ajax/postDeleteTopico.php", data, function (result) {
                                        try {
                                            var retorno = JSON.parse(result);
                                        } catch (e) {
                                            window.console.log("falha no Parse:" + result);
                                            swal(
                                                    {title: "Opss ...",
                                                        type: "error",
                                                        text: "ocorreu uma falha no servidor"});
                                            return;
                                        }
                                        if (retorno.resultado) {
                                            window.location.href = './topicos.php';
                                        } else {
                                            swal(
                                                    {title: "Opss ...",
                                                        type: "error",
                                                        text: "ocorreu uma falha"});
                                            window.console.log(result);
                                        }
                                    });
                                }

                            }
                    );
                }
            <?PHP endif; ?>

            $("#editResposta").submit(function (event) {
                event.preventDefault();
                var id = $("#editResposta > input[name='id']").val();
                var text = $("#editResposta > textarea[name='text']").val();
                $.post('./ajax/postUpdateResposta.php', {id: id, text: text}, function (data) {
                    $('.resposta#' + id + " .text > p").html(text);
                    $('.resposta#' + id + " .data > p").html("<p><b>Última revisão:</b> Agora</p>");

                    $('.editarea').fadeOut(100);
                });
            });

            $(".up").click(function () {
                var id = $(this).parent().parent().attr("id");
                if ($(this).parent().attr('disabled') !== 'disabled')
                {
                    postVote(id, true);
                }
            });

            $(".down").click(function () {
                var id = $(this).parent().parent().attr("id");
                if ($(this).parent().attr('disabled') !== 'disabled')
                {
                    postVote(id, false);
                }
            });

            postVote = function (id, valor) {

                var postData = {
                    'idresp': id,
                    'valor': valor,
                    'id': '<?= $id ?>'
                };

                $.post('./ajax/postVoteResp.php', postData, function (result) {
                    if (valor)
                    {
                        if ($(".resposta[id='" + id + "'] .up").attr('voted') !== 'voted')
                        {
                            $(".resposta[id='" + id + "'] .up").attr("voted", "voted");
                            $(".resposta[id='" + id + "'] .up p").html(parseInt($(".resposta[id='" + id + "'] .up p").html()) + 1);
                            $(".resposta[id='" + id + "'] .down").removeAttr("voted");
                            $(".resposta[id='" + id + "'] .down p").html(Math.max(parseInt($(".resposta[id='" + id + "'] .down p").html()) - 1, 0));
                        } else {
                            $(".resposta[id='" + id + "'] .up").removeAttr("voted");
                            $(".resposta[id='" + id + "'] .up p").html(Math.max(parseInt($(".resposta[id='" + id + "'] .up p").html()) - 1, 0));
                        }
                    } else
                    {
                        if ($(".resposta[id='" + id + "'] .down").attr('voted') !== 'voted')
                        {
                            $(".resposta[id='" + id + "'] .down p").html(parseInt($(".resposta[id='" + id + "'] .down p").html()) + 1);
                            $(".resposta[id='" + id + "'] .down").attr("voted", "voted");
                            $(".resposta[id='" + id + "'] .up").removeAttr("voted");
                            $(".resposta[id='" + id + "'] .up p").html(Math.max(parseInt($(".resposta[id='" + id + "'] .up p").html()) - 1, 0));
                        } else
                        {
                            $(".resposta[id='" + id + "'] .down").removeAttr("voted");
                            $(".resposta[id='" + id + "'] .down p").html(Math.max(parseInt($(".resposta[id='" + id + "'] .down p").html()) - 1, 0));
                        }
                    }
                });


            };

            function removeResposta(id) {
                swal({
                    title: "Você tem certeza?",
                    text: "Deseja remover por completo a resposta!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: "Remover",
                    cancelButtonText: "Cancelar",
                    closeOnConfirm: true,
                    closeOnCancel: true},
                        function (isConfirm)
                        {
                            if (isConfirm) {

                                var postData = {
                                    id: id
                                };

                                $.post('./ajax/postDeleteResposta.php', postData, function () {
                                    $(".resposta#" + id).remove();
                                    $("#cont").html(parseInt($("#cont").html()) - 1);
                                });
                            }
                            return;
                        });
            }

            $(".resposta .editbtn").click(function () {
                var id = $(this).parent().parent().attr('id');

                $("#editResposta input[name='id']").val(id);
                $("#editResposta textarea").html($(".resposta[id='" + id + "'] .text p").html());
                $("#editResposta textarea").animate({'height': $(".resposta[id='" + id + "'] .text p").height() + 50}, 200);
                $(".editarea").fadeIn(100);

            });

            $("#gotohub").click(function () {
                $("#huboptions").fadeToggle(100);
            });

        </script>
    </body>
</html>
